
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

function Create()
	Set(this,"HeadLightsSpawned","no")
end

function ChangeSubTypeClicked()
	if this.SubType == 0 then this.SubType = 1
	elseif this.SubType == 1 then this.SubType = 2
	elseif this.SubType == 2 then this.SubType = 3
	elseif this.SubType == 3 then this.SubType = 4
	elseif this.SubType == 4 then this.SubType = 5
	elseif this.SubType == 5 then this.SubType = 6
	elseif this.SubType == 6 then this.SubType = 7
	elseif this.SubType == 7 then this.SubType = 8
	elseif this.SubType == 8 then this.SubType = 0
	end
	this.SetInterfaceCaption("ChangeSubType", "tooltip_Decorative_CargoTruck",this.SubType+1,"X")
end

function SpawnHeadLights()
	newHL = Object.Spawn("Light",this.Pos.x,this.Pos.y)
	Set(newHL,"HomeUID",this.HomeUID)
	newHR = Object.Spawn("Light",this.Pos.x,this.Pos.y)
	Set(newHR,"HomeUID",this.HomeUID)
	Set(this,"Slot1.i",newHL.Id.i)
	Set(this,"Slot1.u",newHL.Id.u)
	newHL.Loaded = true
	Set(this,"Slot2.i",newHR.Id.i)
	Set(this,"Slot2.u",newHR.Id.u)
	newHR.Loaded = true
	Set(this,"HeadLightsSpawned","yes")
end

function RemoveHeadLights()
	local loadedHeadlights=Find(this,"Light",10)
	for thatLight, distance in pairs(loadedHeadlights) do
		if Get(thatLight,"HomeUID") ~= nil and thatLight.HomeUID == this.HomeUID then
			thatLight.Delete()
		end
	end
	Set(this,"HeadLightsSpawned","no")
end

function toggleHeadLightsClicked()
	if this.HeadLightsSpawned == "no" then
		SpawnHeadLights()
	else
		RemoveHeadLights()
	end
	this.SetInterfaceCaption("toggleHeadLights", "tooltip_Decorative_Headlights",this.HeadLightsSpawned,"X")
end

function Update(timePassed)
	if buttonsSet == nil then
		Set(this,"HomeUID","Eyecandy_"..me["id-uniqueId"])
		Interface.AddComponent(this,"SeparatorVehicle", "Caption", "tooltip_Decorative_Separatorline")
		Interface.AddComponent(this,"ChangeSubType", "Button", "tooltip_Decorative_CargoTruck",this.SubType+1,"X")
		Interface.AddComponent( this,"toggleHeadLights", "Button", "tooltip_Decorative_Headlights",this.HeadLightsSpawned,"X")
		buttonsSet = true
	end
end

