
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local TeamChar = { [0] = "None", [1] = "A", [2] = "B", [3] = "C", [4] = "D", [5] = "E", [6] = "F", [7] = "G", [8] = "H", [9] = "I", [10] = "J", [11] = "K", [12] = "L", [13] = "M", [14] = "N", [15] = "O", [16] = "P", [17] = "Q", [18] = "R", [19] = "S", [20] = "T", [21] = "U", [22] = "V", [23] = "W", [24] = "X", [25] = "Y", [26] = "Z" }

function Create()
	print("Create")
	MySprinkler = Object.Spawn("Sprinkler",this.Pos.x,this.Pos.y)
	this.Slot0.i = MySprinkler.Id.i
	this.Slot0.u = MySprinkler.Id.u
	MySprinkler.CarrierId.i = this.Id.i
	MySprinkler.CarrierId.u = this.Id.u
	MySprinkler.Loaded = true
	MySprinkler.Hidden = true
	Set(this,"SprinklerID",MySprinkler.Id.u)
	print("MySprinkler created")
	Set(this,"Team",0)
	Set(this,"Member",0)
end

function FindMySprinkler()
	print("FindMySprinkler")
	local found = false
	local nearbySprinklers = Find(this,"Sprinkler",1)
	if next(nearbySprinklers) then
		for thatSprinkler, distance in pairs(nearbySprinklers) do
			if Get(thatSprinkler,"Id.u") == Get(this,"SprinklerID") then
				MySprinkler = thatSprinkler
				found = true
			end
		end
	end
	nearbySprinklers = nil
	if found == true then
		print("MySprinkler found")
	else
		print("MySprinkler created")
		Create()
	end
end

function FindFiremanLocker()
	print("FindFiremanLocker")
	local found = false
	local nearbyLockers = Find(this,"FiremanLocker2",10000)
	if next(nearbyLockers) then
		for thatLocker, distance in pairs(nearbyLockers) do
			if Get(thatLocker,"Id.u") == Get(this,"LockerID") then
				MyLocker = thatLocker
				found = true
			end
		end
	end
	nearbyLockers = nil
	if found == true then
		print("MyLocker found")
	else
		print("No FiremanLocker with "..this.LockerID.." found")
	end
end

function TurnShowerOn()
	print("TurnShowerOn T"..TeamChar[Get(this,"Team")].."M"..Get(this,"Member"))
	if not Exists(MySprinkler) then FindMySprinkler() end
	MySprinkler.Active = true
	Object.CreateJob(this,"FiremanShowerT"..this.Team.."M"..this.Member)
end

function TurnShowerOff()
	print("TurnShowerOff T"..TeamChar[Get(this,"Team")].."M"..Get(this,"Member"))
	if not Exists(MySprinkler) then FindMySprinkler() end
	MySprinkler.Active = false
	Object.CancelJob(this,"FiremanShowerT"..this.Team.."M"..this.Member)
end

function ChangeClothes()
	TurnShowerOff()
	print("ChangeClothes T"..TeamChar[Get(this,"Team")].."M"..Get(this,"Member"))
	local nearbyFireman = Find(this,"PrisonFiremanT"..this.Team.."M"..this.Member,2)
	if next(nearbyFireman) then
		for thatFireman, dist in pairs(nearbyFireman) do
			print("Found PrisonFiremanT"..TeamChar[this.Team].."M"..this.Member)
			FindFiremanLocker()
			if Exists(MyLocker) then
				Object.CreateJob(MyLocker,"ChangeFiremanClothesT"..this.Team.."M"..this.Member)
			end
			Set(thatFireman,"SubType",3)	-- naked and fresh
			Set(thatFireman,"Energy",100)
			Set(thatFireman,"Damage",0)
			break
		end
	end
	nearbyFireman = nil
	MyLocker = nil
	Set(this,"Team",0)
	Set(this,"Member",0)
	Set(this,"LockerID",nil)
	Set(this,"InUse",nil)
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

function JobComplete_FiremanTurnOnShowerT1M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT1M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT1M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT1M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT2M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT2M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT2M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT2M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT3M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT3M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT3M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT3M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT4M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT4M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT4M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT4M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT5M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT5M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT5M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT5M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT6M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT6M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT6M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT6M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT7M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT7M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT7M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT7M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT8M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT8M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT8M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT8M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT9M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT9M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT9M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT9M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT10M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT10M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT10M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT10M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT11M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT11M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT11M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT11M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT12M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT12M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT12M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT12M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT13M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT13M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT13M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT13M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT14M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT14M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT14M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT14M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT15M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT15M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT15M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT15M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT16M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT16M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT16M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT16M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT17M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT17M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT17M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT17M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT18M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT18M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT18M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT18M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT19M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT19M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT19M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT19M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT20M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT20M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT20M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT20M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT21M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT21M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT21M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT21M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT22M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT22M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT22M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT22M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT23M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT23M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT23M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT23M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT24M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT24M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT24M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT24M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT25M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT25M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT25M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT25M4() TurnShowerOn() end

function JobComplete_FiremanTurnOnShowerT26M1() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT26M2() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT26M3() TurnShowerOn() end
function JobComplete_FiremanTurnOnShowerT26M4() TurnShowerOn() end

function JobComplete_FiremanShowerT1M1() ChangeClothes() end
function JobComplete_FiremanShowerT1M2() ChangeClothes() end
function JobComplete_FiremanShowerT1M3() ChangeClothes() end
function JobComplete_FiremanShowerT1M4() ChangeClothes() end

function JobComplete_FiremanShowerT2M1() ChangeClothes() end
function JobComplete_FiremanShowerT2M2() ChangeClothes() end
function JobComplete_FiremanShowerT2M3() ChangeClothes() end
function JobComplete_FiremanShowerT2M4() ChangeClothes() end

function JobComplete_FiremanShowerT3M1() ChangeClothes() end
function JobComplete_FiremanShowerT3M2() ChangeClothes() end
function JobComplete_FiremanShowerT3M3() ChangeClothes() end
function JobComplete_FiremanShowerT3M4() ChangeClothes() end

function JobComplete_FiremanShowerT4M1() ChangeClothes() end
function JobComplete_FiremanShowerT4M2() ChangeClothes() end
function JobComplete_FiremanShowerT4M3() ChangeClothes() end
function JobComplete_FiremanShowerT4M4() ChangeClothes() end

function JobComplete_FiremanShowerT5M1() ChangeClothes() end
function JobComplete_FiremanShowerT5M2() ChangeClothes() end
function JobComplete_FiremanShowerT5M3() ChangeClothes() end
function JobComplete_FiremanShowerT5M4() ChangeClothes() end

function JobComplete_FiremanShowerT6M1() ChangeClothes() end
function JobComplete_FiremanShowerT6M2() ChangeClothes() end
function JobComplete_FiremanShowerT6M3() ChangeClothes() end
function JobComplete_FiremanShowerT6M4() ChangeClothes() end

function JobComplete_FiremanShowerT7M1() ChangeClothes() end
function JobComplete_FiremanShowerT7M2() ChangeClothes() end
function JobComplete_FiremanShowerT7M3() ChangeClothes() end
function JobComplete_FiremanShowerT7M4() ChangeClothes() end

function JobComplete_FiremanShowerT8M1() ChangeClothes() end
function JobComplete_FiremanShowerT8M2() ChangeClothes() end
function JobComplete_FiremanShowerT8M3() ChangeClothes() end
function JobComplete_FiremanShowerT8M4() ChangeClothes() end

function JobComplete_FiremanShowerT9M1() ChangeClothes() end
function JobComplete_FiremanShowerT9M2() ChangeClothes() end
function JobComplete_FiremanShowerT9M3() ChangeClothes() end
function JobComplete_FiremanShowerT9M4() ChangeClothes() end

function JobComplete_FiremanShowerT10M1() ChangeClothes() end
function JobComplete_FiremanShowerT10M2() ChangeClothes() end
function JobComplete_FiremanShowerT10M3() ChangeClothes() end
function JobComplete_FiremanShowerT10M4() ChangeClothes() end

function JobComplete_FiremanShowerT11M1() ChangeClothes() end
function JobComplete_FiremanShowerT11M2() ChangeClothes() end
function JobComplete_FiremanShowerT11M3() ChangeClothes() end
function JobComplete_FiremanShowerT11M4() ChangeClothes() end

function JobComplete_FiremanShowerT12M1() ChangeClothes() end
function JobComplete_FiremanShowerT12M2() ChangeClothes() end
function JobComplete_FiremanShowerT12M3() ChangeClothes() end
function JobComplete_FiremanShowerT12M4() ChangeClothes() end

function JobComplete_FiremanShowerT13M1() ChangeClothes() end
function JobComplete_FiremanShowerT13M2() ChangeClothes() end
function JobComplete_FiremanShowerT13M3() ChangeClothes() end
function JobComplete_FiremanShowerT13M4() ChangeClothes() end

function JobComplete_FiremanShowerT14M1() ChangeClothes() end
function JobComplete_FiremanShowerT14M2() ChangeClothes() end
function JobComplete_FiremanShowerT14M3() ChangeClothes() end
function JobComplete_FiremanShowerT14M4() ChangeClothes() end

function JobComplete_FiremanShowerT15M1() ChangeClothes() end
function JobComplete_FiremanShowerT15M2() ChangeClothes() end
function JobComplete_FiremanShowerT15M3() ChangeClothes() end
function JobComplete_FiremanShowerT15M4() ChangeClothes() end

function JobComplete_FiremanShowerT16M1() ChangeClothes() end
function JobComplete_FiremanShowerT16M2() ChangeClothes() end
function JobComplete_FiremanShowerT16M3() ChangeClothes() end
function JobComplete_FiremanShowerT16M4() ChangeClothes() end

function JobComplete_FiremanShowerT17M1() ChangeClothes() end
function JobComplete_FiremanShowerT17M2() ChangeClothes() end
function JobComplete_FiremanShowerT17M3() ChangeClothes() end
function JobComplete_FiremanShowerT17M4() ChangeClothes() end

function JobComplete_FiremanShowerT18M1() ChangeClothes() end
function JobComplete_FiremanShowerT18M2() ChangeClothes() end
function JobComplete_FiremanShowerT18M3() ChangeClothes() end
function JobComplete_FiremanShowerT18M4() ChangeClothes() end

function JobComplete_FiremanShowerT19M1() ChangeClothes() end
function JobComplete_FiremanShowerT19M2() ChangeClothes() end
function JobComplete_FiremanShowerT19M3() ChangeClothes() end
function JobComplete_FiremanShowerT19M4() ChangeClothes() end

function JobComplete_FiremanShowerT20M1() ChangeClothes() end
function JobComplete_FiremanShowerT20M2() ChangeClothes() end
function JobComplete_FiremanShowerT20M3() ChangeClothes() end
function JobComplete_FiremanShowerT20M4() ChangeClothes() end

function JobComplete_FiremanShowerT21M1() ChangeClothes() end
function JobComplete_FiremanShowerT21M2() ChangeClothes() end
function JobComplete_FiremanShowerT21M3() ChangeClothes() end
function JobComplete_FiremanShowerT21M4() ChangeClothes() end

function JobComplete_FiremanShowerT22M1() ChangeClothes() end
function JobComplete_FiremanShowerT22M2() ChangeClothes() end
function JobComplete_FiremanShowerT22M3() ChangeClothes() end
function JobComplete_FiremanShowerT22M4() ChangeClothes() end

function JobComplete_FiremanShowerT23M1() ChangeClothes() end
function JobComplete_FiremanShowerT23M2() ChangeClothes() end
function JobComplete_FiremanShowerT23M3() ChangeClothes() end
function JobComplete_FiremanShowerT23M4() ChangeClothes() end

function JobComplete_FiremanShowerT24M1() ChangeClothes() end
function JobComplete_FiremanShowerT24M2() ChangeClothes() end
function JobComplete_FiremanShowerT24M3() ChangeClothes() end
function JobComplete_FiremanShowerT24M4() ChangeClothes() end

function JobComplete_FiremanShowerT25M1() ChangeClothes() end
function JobComplete_FiremanShowerT25M2() ChangeClothes() end
function JobComplete_FiremanShowerT25M3() ChangeClothes() end
function JobComplete_FiremanShowerT25M4() ChangeClothes() end

function JobComplete_FiremanShowerT26M1() ChangeClothes() end
function JobComplete_FiremanShowerT26M2() ChangeClothes() end
function JobComplete_FiremanShowerT26M3() ChangeClothes() end
function JobComplete_FiremanShowerT26M4() ChangeClothes() end
