
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local timeTot = 0
local UpdateTracks = true

function Create()
	Set(this,"UpdateTracks",true)
	this.Tooltip = "tooltip_RailwayManager"
end

function Update(timePassed)
	if timePerUpdate == nil then
		for existingManagers in next, Find(this,"RailwayManager",10000) do
			if existingManagers.Id.u ~= this.Id.u then existingManagers.Delete() end
		end
		timePerUpdate = math.random(30,60) / World.TimeWarpFactor
	end
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		
		if UpdateTracks == true or this.UpdateTracks == true then
			BuildTrackList()
		end
		if #MyTracks > 0 then
			local AssignedTrack = math.random(1,#MyTracks)
			if Exists(MyTracks[AssignedTrack]) and MyTracks[AssignedTrack].RailwayCreated and MyTracks[AssignedTrack].Wagons > 0 then
				MyTracks[AssignedTrack].SpawnTrain = true
				timePerUpdate = math.random(30,60) / World.TimeWarpFactor
			else
				UpdateTracks = true
			end
		end
	end
end

function BuildTrackList()
	print("BuildTrackList")
	MyTracks = {}
	local RailwayTracks = Find(this,"TrainSpawner",10000)
	if next(RailwayTracks) then
		for thatTrack, dist in pairs(RailwayTracks) do
			table.insert(MyTracks,thatTrack)
		end
	end
	RailwayTracks = nil
	UpdateTracks = false
	Set(this,"UpdateTracks",false)
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end
