
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local Direction = 0
local SpeedX = 0
local SpeedY = 0
local DeleteAt = 0
local FromX = 0
local FromY = 0

-- local timeTot = 0
-- local timePerUpdate = 0.25

function Create()
	Set(this,"Wagons",0)
end

function Update(timePassed)
	if not InitDone then
		if this.Or.x == 0 and this.Or.y == 1 then			-- train goes from top to bottom
			Direction = 1
			SpeedX = 0
			SpeedY = 8
			FromY = 0
			DeleteAt = World.NumCellsY-1
		elseif this.Or.x == 0 and this.Or.y == -1 then		-- train goes from bottom to top
			Direction = 2
			SpeedX = 0
			SpeedY = -8
			FromY = World.NumCellsY
			DeleteAt = 1
		elseif this.Or.x == 1 and this.Or.y == 0 then		-- train goes from left to right
			Direction = 3
			SpeedX = 8
			SpeedY = 0
			FromX = 0
			DeleteAt = World.NumCellsX-1
		elseif this.Or.x == -1 and this.Or.y == 0 then		-- train goes from right to left
			Direction = 4
			SpeedX = -8
			SpeedY = 0
			FromX = World.NumCellsX
			DeleteAt = 1
		end
		InitDone = true
	end
	
	if this.WagonsToSpawn > this.Wagons then
		if Direction == 1 and this.Pos.y >= this.Wagons * 6 then	-- each wagon is 6 tiles long
			this.Wagons = this.Wagons + 1
			local newWagon =  Object.Spawn("Train2",this.Pos.x,FromY)
			newWagon.Or.x = this.Or.x
			newWagon.Or.y = this.Or.y
			newWagon.Pos.y = this.Pos.y - (this.Wagons * 6 )
			if this.Wagons == 1 then newWagon.Delete() end -- only needed for PA2018
		elseif Direction == 2 and this.Pos.y <= FromY - (this.Wagons * 6) then
			this.Wagons = this.Wagons + 1
			local newWagon =  Object.Spawn("Train2",this.Pos.x,FromY)
			newWagon.Or.x = this.Or.x
			newWagon.Or.y = this.Or.y
			newWagon.Pos.y = this.Pos.y + (this.Wagons * 6 )
			if this.Wagons == 1 then newWagon.Delete() end -- only needed for PA2018
		elseif Direction == 3 and this.Pos.x >= this.Wagons * 6 then
			this.Wagons = this.Wagons + 1
			local newWagon =  Object.Spawn("Train2",FromX,this.Pos.y)
			newWagon.Or.x = this.Or.x
			newWagon.Or.y = this.Or.y
			newWagon.Pos.x = this.Pos.x - (this.Wagons * 6 )
			if this.Wagons == 1 then newWagon.Delete() end -- only needed for PA2018
		elseif Direction == 4 and this.Pos.x <= FromX - (this.Wagons * 6) then
			this.Wagons = this.Wagons + 1
			local newWagon =  Object.Spawn("Train2",FromX,this.Pos.y)
			newWagon.Or.x = this.Or.x
			newWagon.Or.y = this.Or.y
			newWagon.Pos.x = this.Pos.x + (this.Wagons * 6 )
			if this.Wagons == 1 then newWagon.Delete() end -- only needed for PA2018
		end
	end
	
	-- timeTot = timeTot + timePassed
	-- if timeTot >= timePerUpdate then						-- not used, makes trains wiggle a bit
		-- timeTot = 0
		
		if		 Direction == 1 and this.Pos.y > DeleteAt then this.Delete()
		elseif	 Direction == 2 and this.Pos.y < DeleteAt then this.Delete()
		elseif	 Direction == 3 and this.Pos.x > DeleteAt then this.Delete()
		elseif	 Direction == 4 and this.Pos.x < DeleteAt then this.Delete()
		end
		
		Object.ApplyVelocity(this,SpeedX,SpeedY,false)
	-- end
end
