
local timeInit = 0
local initTimer = 0.1 + math.random()	-- only used when object is placed down.
								-- this will prevent a dozen objects being placed down at the same time from starting to calculate
								-- the TimeWarp all at the same moment, give your potato a break and spread the cpu load a bit :)
local Now = 0
local StartingMinute = 0
local EndingMinute = 0

local myMapSize = "UNKNOWN"
local mySlowTime = "UNKNOWN"

local myTimeWarpFactor = 0
local timeWarpFound = false

local timeTot = 0

local Set = Object.SetProperty
local Get = Object.GetProperty
-- local Find = Object.GetNearbyObjects

local CurrentHour = math.floor(math.mod(World.TimeIndex,1440) /60)
local CurrentMinute = math.floor(math.mod(World.TimeIndex,60))

local timeFireCheck = 0
local timePerFireCheck = 4	-- timePerUpdate gets set to 2 when CheckForReturningFiremen is true, so it will check for fires every 8 minutes!

local TeamChar = { [0] = "None", [1] = "A", [2] = "B", [3] = "C", [4] = "D", [5] = "E", [6] = "F", [7] = "G", [8] = "H", [9] = "I", [10] = "J", [11] = "K", [12] = "L", [13] = "M", [14] = "N", [15] = "O", [16] = "P", [17] = "Q", [18] = "R", [19] = "S", [20] = "T", [21] = "U", [22] = "V", [23] = "W", [24] = "X", [25] = "Y", [26] = "Z" }

local TankTaken = { [1] = false, [2] = false, [3] = false, [4] = false, [5] = false, [6] = false, [7] = false, [8] = false, [9] = false, [10] = false, [11] = false, [12] = false, [13] = false, [14] = false, [15] = false, [16] = false, [17] = false, [18] = false, [19] = false, [20] = false, [21] = false, [22] = false, [23] = false, [24] = false, [25] = false, [26] = false }

-- Prison Fireman roaming around and linked to this WaterTank waiting for a GrabHose job
local Member1 = ""
local Member2 = ""
local Member3 = ""
local Member4 = ""

-- Real Firemen loaded onto the tank ready to do action or busy on the map fighting fires
local Fireman1 = ""
local Fireman2 = ""
local Fireman3 = ""
local Fireman4 = ""

local fireNumber = 0
local fireTLNumber = 0
local fireTRNumber = 0
local fireBLNumber = 0
local fireBRNumber = 0
local FireScanRange = 75	-- the square range covered by the WaterTank, fires beyond will not be taken care off unless WaterTank is set to Manual mode

local CoveredArea = {}

local allFires = {}
local firesTopLeft = {}
local firesTopRight = {}
local firesBottomLeft = {}
local firesBottomRight = {}

local buttonsAdded = false

local FireAlarm = "OFF"

function Create()
	-- Set(this,"Tooltip","tooltip_Init_TimeWarpA")
	this.SubType = 0
	Set(this,"HomeUID","WaterTank_"..me["id-uniqueId"])
	Set(this,"AutoManual","-MANUAL-")
	Set(this,"CheckForNewMembers",false)
	Set(this,"Member1ID","None")
	Set(this,"Member2ID","None")
	Set(this,"Member3ID","None")
	Set(this,"Member4ID","None")
	Set(this,"TeamMembers",0)
	Set(this,"Fireman1ID","None")
	Set(this,"Fireman2ID","None")
	Set(this,"Fireman3ID","None")
	Set(this,"Fireman4ID","None")
	Set(this,"WaterTankBusy",false)
	Set(this,"Fireman1Available",false)
	Set(this,"Fireman2Available",false)
	Set(this,"Fireman3Available",false)
	Set(this,"Fireman4Available",false)
	Set(this,"FiremanFound",nil)
	Set(this,"Fireman1Deployed",false)
	Set(this,"Fireman2Deployed",false)
	Set(this,"Fireman3Deployed",false)
	Set(this,"Fireman4Deployed",false)
	Set(this,"GrabHose1Done",false)
	Set(this,"GrabHose2Done",false)
	Set(this,"GrabHose3Done",false)
	Set(this,"GrabHose4Done",false)
	Set(this,"SwapGuy1Done",false)
	Set(this,"SwapGuy2Done",false)
	Set(this,"SwapGuy3Done",false)
	Set(this,"SwapGuy4Done",false)
	Set(this,"FiremanBack",nil)
	Set(this,"CheckForReturningFiremen",false)
	Set(this,"Fireman1BackOrDead",false)
	Set(this,"Fireman2BackOrDead",false)
	Set(this,"Fireman3BackOrDead",false)
	Set(this,"Fireman4BackOrDead",false)
	Set(this,"DeadFiremanNr",0)
	Set(this,"ReturningFiremanNr",0)
	fireNumber = 0
	fireTLNumber = 0
	fireTRNumber = 0
	fireBLNumber = 0
	fireBRNumber = 0
	Set(this,"TLquarterDone",nil)
	Set(this,"TLhalfDone",nil)
	Set(this,"TLthreequarterDone",nil)
	Set(this,"TLwholeDone",nil)
	Set(this,"TRquarterDone",nil)
	Set(this,"TRhalfDone",nil)
	Set(this,"TRthreequarterDone",nil)
	Set(this,"TRwholeDone",nil)
	Set(this,"BLquarterDone",nil)
	Set(this,"BLhalfDone",nil)
	Set(this,"BLthreequarterDone",nil)
	Set(this,"BLwholeDone",nil)
	Set(this,"BRquarterDone",nil)
	Set(this,"BRhalfDone",nil)
	Set(this,"BRthreequarterDone",nil)
	Set(this,"BRwholeDone",nil)
	Set(this,"StopScanningForFire",nil)
	Set(this,"NoFiresFound",nil)
	Set(this,"Fireman1Request",false)
	Set(this,"Fireman2Request",false)
	Set(this,"Fireman3Request",false)
	Set(this,"Fireman4Request",false)
	Set(this,"StopScanningForFire",nil)
	Set(this,"SurroundingFiresCleared",nil)
	Set(this,"NoFiresFound",nil)
	Set(this,"FireAlarm","OFF")
	this.Tooltip = "tooltip_init_WaterTank"
	Set(this,"WaterTankSearcherID","None")
end

function FindMyChief()
	print("FindMyChief")
	local found = false
	local nearbyChiefs = Find("PrisonFireman2Chief",10000)
	if next(nearbyChiefs) then
		for thatChief, distance in pairs(nearbyChiefs) do
			Set(thatChief,"FindNewWaterTanks",true)
			found = true
			break
		end
	end
	nearbyChiefs = nil
	if found == true then
		print("MyChief found")
	else
		print("No PrisonFireman3Chief")
	end
end

function Init()
	print("cleaning up...")
	this.SubType = 0
	if this.Fireman1ID ~= "None" then Fireman1.Delete() end
	if this.Fireman2ID ~= "None" then Fireman2.Delete() end
	if this.Fireman3ID ~= "None" then Fireman3.Delete() end
	if this.Fireman4ID ~= "None" then Fireman4.Delete() end
	Set(this,"Fireman1ID","None")
	Set(this,"Fireman2ID","None")
	Set(this,"Fireman3ID","None")
	Set(this,"Fireman4ID","None")
	Set(this,"WaterTankBusy",false)
	Set(this,"Fireman1Available",false)
	Set(this,"Fireman2Available",false)
	Set(this,"Fireman3Available",false)
	Set(this,"Fireman4Available",false)
	Set(this,"FiremanFound",nil)
	Set(this,"Fireman1Deployed",false)
	Set(this,"Fireman2Deployed",false)
	Set(this,"Fireman3Deployed",false)
	Set(this,"Fireman4Deployed",false)
	Set(this,"GrabHose1Done",false)
	Set(this,"GrabHose2Done",false)
	Set(this,"GrabHose3Done",false)
	Set(this,"GrabHose4Done",false)
	Set(this,"SwapGuy1Done",false)
	Set(this,"SwapGuy2Done",false)
	Set(this,"SwapGuy3Done",false)
	Set(this,"SwapGuy4Done",false)
	Set(this,"FiremanBack",nil)
	Set(this,"CheckForReturningFiremen",false)
	Set(this,"Fireman1BackOrDead",false)
	Set(this,"Fireman2BackOrDead",false)
	Set(this,"Fireman3BackOrDead",false)
	Set(this,"Fireman4BackOrDead",false)
	Set(this,"DeadFiremanNr",0)
	Set(this,"ReturningFiremanNr",0)
	fireNumber = 0
	fireTLNumber = 0
	fireTRNumber = 0
	fireBLNumber = 0
	fireBRNumber = 0
	Set(this,"TLquarterDone",nil)
	Set(this,"TLhalfDone",nil)
	Set(this,"TLthreequarterDone",nil)
	Set(this,"TLwholeDone",nil)
	Set(this,"TRquarterDone",nil)
	Set(this,"TRhalfDone",nil)
	Set(this,"TRthreequarterDone",nil)
	Set(this,"TRwholeDone",nil)
	Set(this,"BLquarterDone",nil)
	Set(this,"BLhalfDone",nil)
	Set(this,"BLthreequarterDone",nil)
	Set(this,"BLwholeDone",nil)
	Set(this,"BRquarterDone",nil)
	Set(this,"BRhalfDone",nil)
	Set(this,"BRthreequarterDone",nil)
	Set(this,"BRwholeDone",nil)
	Set(this,"StopScanningForFire",nil)
	Set(this,"SurroundingFiresCleared",nil)
	Set(this,"NoFiresFound",nil)
	Set(this,"Fireman1Request",false)
	Set(this,"Fireman2Request",false)
	Set(this,"Fireman3Request",false)
	Set(this,"Fireman4Request",false)
	Set(this,"WaterTankSearcherID","None")
	local AvailableHoses = Find("HoseIcon",2)
	for thatHose, dist in pairs(AvailableHoses) do
		thatHose.Delete()
	end
	AvailableHoses = nil
	
	for obj in next, Object.GetNearbyObjects(this,"HoseXY",4) do
		if obj.TankUID ~= nil and obj.TankUID == this.Id.u then
			obj.Delete()
		end
	end
	
	this.Tooltip = { "tooltip_WaterTank",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M" }
	timePerUpdate = 1+math.random() / myTimeWarpFactor
	print("WaterTank ready for next CallOut...")
end

function Update(timePassed)
	if this.TimeWarp == nil then
		Set(this,"TimeWarp",World.TimeWarpFactor)
		
		local nearbyWaterTanks = Find("WaterTank2",10000)
		for thatTank, dist in pairs(nearbyWaterTanks) do
			if thatTank.Id.i ~= this.Id.i and thatTank.Team ~= nil then
				TankTaken[thatTank.Team] = true
			end
		end
		for T = 1,26 do
			if TankTaken[T] == false then
				Set(this,"Team",T)
				break
			end
		end
		if this.Team == nil then
			this.Delete()
			return
		end	-- max 26 tanks allowed
		
		local x = math.floor(this.Pos.x);	local y = math.floor(this.Pos.y)
		local Xmax = 0; local Xmin = 0
		local Ymax = 0; local Ymin = 0
		for i=Ymin-1,Ymax+1 do	for j=Xmin-1,Xmax+1 do	local cell = World.GetCell(x+j,y+i);	cell.Mat = "ConcreteTiles"	end	end
		
		waterWave = Object.Spawn("Sprinkler",this.Pos.x,this.Pos.y)
		waterWave.Hidden = true
		Set(this,"SprinklerSpawned",true)
		FindMyChief()
		return
	end
	if timePerUpdate == nil then
		if not this.Initialised then return end
		FireAlarm = Get(this,"FireAlarm")
		
		this.Tooltip = { "tooltip_WaterTank",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M" }
		if not this.FiremanBack and this.CheckForReturningFiremen == true then
			if this.AutoManual == "AUTO" then 
				this.Tooltip = { "tooltip_Watertank_FiremenAutoWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",fireNumber,"D",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
			else
				this.Tooltip = { "tooltip_Watertank_FiremenManualWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
			end
		end
		
		Interface.AddComponent(this,"toggleShowCoveredFireArea", "Button", "tooltip_button_ShowHideRange",FireScanRange,"X")
		
		Interface.AddComponent(this,this.HomeUID.."AlarmCaption", "Caption", "tooltip_caption_FireAlarm2Toggle")
		Interface.AddComponent(this,"toggleFireAlarm", "Button", "tooltip_button_FireAlarm2Toggle",FireAlarm,"F")
		
		if Get(this,"TeamMembers") > 0 then
			buttonsAdded = true
			Interface.AddComponent(this,"CaptionSeparatorWaterTank", "Caption", "tooltip_separatorAutoManual")
			Interface.AddComponent(this,"toggleAutoManual", "Button", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
			if Get(this,"TeamMembers") == 3 then
				if this.AutoManual == "AUTO" then
					Set(this,"AutoManual","-MANUAL-") 
					this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
				end
			else
				this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
			end
		end
	-------------------------------------------------------------------------------------------
	-- Load References
	-------------------------------------------------------------------------------------------
		
		print("load my team")
		Member1 = Load(Member1,"PrisonFiremanT"..this.Team.."M1","Member1ID",10000); if this.Member1ID ~= "None" then Member1.Tooltip = { "tooltip_PrisonFireman2",this.HomeUID,"W",TeamChar[this.Team],"T",Member1.Member,"M",Member1.Rank,"R" } end
		Member2 = Load(Member2,"PrisonFiremanT"..this.Team.."M2","Member2ID",10000); if this.Member2ID ~= "None" then Member2.Tooltip = { "tooltip_PrisonFireman2",this.HomeUID,"W",TeamChar[this.Team],"T",Member2.Member,"M",Member2.Rank,"R" } end
		Member3 = Load(Member3,"PrisonFiremanT"..this.Team.."M3","Member3ID",10000); if this.Member3ID ~= "None" then Member3.Tooltip = { "tooltip_PrisonFireman2",this.HomeUID,"W",TeamChar[this.Team],"T",Member3.Member,"M",Member3.Rank,"R" } end
		Member4 = Load(Member4,"PrisonFiremanT"..this.Team.."M4","Member4ID",10000); if this.Member4ID ~= "None" then Member4.Tooltip = { "tooltip_PrisonFireman2",this.HomeUID,"W",TeamChar[this.Team],"T",Member4.Member,"M",Member4.Rank,"R" } end
		
		
		print("load firemen")
		Fireman1 = Load(Fireman1,"Fireman","Fireman1ID",10000); if this.Fireman1ID ~= "None" then if this.GrabHose1Done == true then Fireman1.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",1,"M","Firefighter","R" } else Fireman1.Tooltip = "tooltip_RealFiremanQueued" end end
		Fireman2 = Load(Fireman2,"Fireman","Fireman2ID",10000); if this.Fireman1ID ~= "None" then if this.GrabHose2Done == true then Fireman2.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",2,"M","Firefighter","R" } else Fireman2.Tooltip = "tooltip_RealFiremanQueued" end end
		Fireman3 = Load(Fireman3,"Fireman","Fireman3ID",10000); if this.Fireman1ID ~= "None" then if this.GrabHose3Done == true then Fireman3.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",3,"M","Firefighter","R" } else Fireman3.Tooltip = "tooltip_RealFiremanQueued" end end
		Fireman4 = Load(Fireman4,"Fireman","Fireman4ID",10000); if this.Fireman1ID ~= "None" then if this.GrabHose4Done == true then Fireman4.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",4,"M","Crew Manager","R" } else Fireman4.Tooltip = "tooltip_RealFiremanQueued" end end
		
		myTimeWarpFactor = this.TimeWarp
		timePerUpdate = 1+math.random() / myTimeWarpFactor
		timePerFireCheck = timePerFireCheck / myTimeWarpFactor
		
		if not this.FiremanBack and this.CheckForReturningFiremen == true then		-- set a random fire check timeout, otherwise all water tanks would suddenly scan at once after a load game
			timeFireCheck = math.random(1,timePerFireCheck)+math.random()+math.random()+math.random() / myTimeWarpFactor
			timePerUpdate = 2+math.random() / myTimeWarpFactor
		end
	end
	-------------------------------------------------------------------------------------------
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		
		if this.WaterTankBusy == true then								-- a CallOut from the WaterTankSearcher awakened me
			if FireAlarm == "ON" then FireAlarm = "OFF"; Set(this,"FiresInRangeDetected",nil) end	-- a value for the PrisonFireAlarm2 object, turn off when tank is busy so the alarm only sounds for this tank when specific call-out is not operational yet
			
			if this.CheckForNewMembers == true then CheckMyMembers() end	-- a new fireman was hired after an active fireman was killed in action, check for the new member
			if not this.FiremanFound then									-- find the firemen which were swapped from the WaterTankSearcher to me
				print("find callout fireman")
				if this.TeamMembers >= 1 then Fireman1 = ""; Fireman1 = Load(Fireman1,"Fireman","Fireman1ID",3) end
				if this.TeamMembers >= 2 then Fireman2 = ""; Fireman2 = Load(Fireman2,"Fireman","Fireman2ID",3) end
				if this.TeamMembers >= 3 then Fireman3 = ""; Fireman3 = Load(Fireman3,"Fireman","Fireman3ID",3) end
				if this.TeamMembers >= 4 then Fireman4 = ""; Fireman4 = Load(Fireman4,"Fireman","Fireman4ID",3) end
				ClearSurroundingFires()				-- removes fires in vicinity of the WaterTank, otherwise the jobs will get Too Dangerous
				Set(this,"FiremanFound",true)
				print("deploy fireman")
				
			else
				-- start PA 2018 code
				if this.GrabHose1Done == true and this.SwapGuy1Done == false then DeployFireman(Fireman1,1) end
				if this.GrabHose2Done == true and this.SwapGuy2Done == false then DeployFireman(Fireman2,2) end
				if this.GrabHose3Done == true and this.SwapGuy3Done == false then DeployFireman(Fireman3,3) end
				if this.GrabHose4Done == true and this.SwapGuy4Done == false then DeployFireman(Fireman4,4) end
				-- finish PA 2018 code
				
				-- deploy the firemen after GrabHose jobs completed, but let them finish their shower first in case they are called for duty a second time
				if this.Fireman1Deployed == false then if this.Member1ID ~= "None" and Get(Member1,"ShowerSequenceStarted") == false then DeployFireman(Fireman1,1) end end
				if this.Fireman2Deployed == false then if this.Member2ID ~= "None" and Get(Member2,"ShowerSequenceStarted") == false then DeployFireman(Fireman2,2) end end
				if this.Fireman3Deployed == false then if this.Member3ID ~= "None" and Get(Member3,"ShowerSequenceStarted") == false then DeployFireman(Fireman3,3) end end
				if this.Fireman4Deployed == false then if this.Member4ID ~= "None" and Get(Member4,"ShowerSequenceStarted") == false then DeployFireman(Fireman4,4) end end
			end
		else																-- check for deleted or new team members
			if this.Member1ID ~= "None" and Member1.Energy == nil then Set(this,"CheckForNewMembers",true) end
			if this.Member2ID ~= "None" and Member2.Energy == nil then Set(this,"CheckForNewMembers",true) end
			if this.Member3ID ~= "None" and Member3.Energy == nil then Set(this,"CheckForNewMembers",true) end
			if this.Member4ID ~= "None" and Member4.Energy == nil then Set(this,"CheckForNewMembers",true) end
			if this.CheckForNewMembers == true then CheckMyMembers() end
			
			FireAlarm = this.FireAlarm
			if FireAlarm == "ON" then CheckForFiresInRange() end	-- a function for the PrisonFireAlarm2 object
		end
		
						-- check for returning firemen and spawn a Prison Fireman back in place when needed
						-- there is no way to be 100% sure that firemen will return, so keeping it outside the If above should make sure the tank doesn't get stuck at some point

		if not this.FiremanBack and this.CheckForReturningFiremen == true then
			timeFireCheck = timeFireCheck+1
			if timeFireCheck >= timePerFireCheck then	-- checks every ~8 minutes for fires and repositions the firemen to a location near that fire
				timeFireCheck = 0
				if not this.StopScanningForFire and this.AutoManual == "AUTO" then CheckIfFiresAreGone() end
			end
			if this.Fireman1ID == "None" then Set(this,"Fireman1BackOrDead",true) end
			if this.Fireman2ID == "None" then Set(this,"Fireman2BackOrDead",true) end
			if this.Fireman3ID == "None" then Set(this,"Fireman3BackOrDead",true) end
			if this.Fireman4ID == "None" then Set(this,"Fireman4BackOrDead",true) end
				-- not vanished from the map, not dead yet, but loaded? then it's ok. If all are ok then we leave.
			if this.Fireman1ID ~= "None" and this.GrabHose1Done == true then CheckReturningFireman(Fireman1,1) elseif this.GrabHose1Done == true then Set(this,"Fireman1BackOrDead",true) end
			if this.Fireman2ID ~= "None" and this.GrabHose2Done == true then CheckReturningFireman(Fireman2,2) elseif this.GrabHose2Done == true then Set(this,"Fireman2BackOrDead",true) end
			if this.Fireman3ID ~= "None" and this.GrabHose3Done == true then CheckReturningFireman(Fireman3,3) elseif this.GrabHose3Done == true then Set(this,"Fireman3BackOrDead",true) end
			if this.Fireman4ID ~= "None" and this.GrabHose4Done == true then CheckReturningFireman(Fireman4,4) elseif this.GrabHose4Done == true then Set(this,"Fireman4BackOrDead",true) end
			if this.AutoManual == "AUTO" then 
				this.Tooltip = { "tooltip_Watertank_FiremenAutoWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",fireNumber,"D",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
			else
				this.Tooltip = { "tooltip_Watertank_FiremenManualWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
			end
			if this.Fireman1BackOrDead == true and this.Fireman2BackOrDead == true and this.Fireman3BackOrDead == true and this.Fireman4BackOrDead == true then
				print("firemen are all back")
				Init()
			end
		end
		
		
	else		-- keep the firemen below the watertank until they are free to go, to prevent the player from moving the callout too soon and fking up the whole procedure
		if this.WaterTankBusy == true then
			if Fireman1.Energy ~= nil and this.Fireman1Available == true then Fireman1.ClearRouting(); Fireman1.Pos.x = this.Pos.x; Fireman1.Pos.y = this.Pos.y; this.Slot4.i = Fireman1.Id.i; this.Slot4.u = Fireman1.Id.u end
			if Fireman2.Energy ~= nil and this.Fireman2Available == true then Fireman2.ClearRouting(); Fireman2.Pos.x = this.Pos.x; Fireman2.Pos.y = this.Pos.y; this.Slot5.i = Fireman2.Id.i; this.Slot5.u = Fireman2.Id.u end
			if Fireman3.Energy ~= nil and this.Fireman3Available == true then Fireman3.ClearRouting(); Fireman3.Pos.x = this.Pos.x; Fireman3.Pos.y = this.Pos.y; this.Slot6.i = Fireman3.Id.i; this.Slot6.u = Fireman3.Id.u end
			if Fireman4.Energy ~= nil and this.Fireman4Available == true then Fireman4.ClearRouting(); Fireman4.Pos.x = this.Pos.x; Fireman4.Pos.y = this.Pos.y; this.Slot7.i = Fireman4.Id.i; this.Slot7.u = Fireman4.Id.u end
		end
	end
end

function toggleFireAlarmClicked()	-- enable/disable scanning for fires when tank is not busy, to give a signal to the PrisonFireAlarm2 object
	if this.FireAlarm == "ON" then
		FireAlarm = "OFF"
		Set(this,"FireAlarm","OFF")
	else
		FireAlarm = "ON"
		Set(this,"FireAlarm","ON")
	end
	this.SetInterfaceCaption("toggleFireAlarm", "tooltip_button_FireAlarm2Toggle",this.FireAlarm,"F")
		this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
		
	this.Tooltip = { "tooltip_WaterTank",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M" }
	if not this.FiremanBack and this.CheckForReturningFiremen == true then
		if this.AutoManual == "AUTO" then 
			this.Tooltip = { "tooltip_Watertank_FiremenAutoWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",fireNumber,"D",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
		else
			this.Tooltip = { "tooltip_Watertank_FiremenManualWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
		end
	end
end

function DeployFireman(theFireman,theNr)	-- create GrabHose jobs until the corresponding fireman is deployed, then swap his FireEngine id to make the hose appear below me
	print("function DeployFireman "..theNr)
	if Get(this,"GrabHose"..theNr.."Done") == true then
		print("fireman "..theNr.." deployed")
		Set(this,"Fireman"..theNr.."BackOrDead",false)
		this.Tooltip = {"tooltip_Watertank_FiremenDeployedNr",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M" }

		-- start PA 2018 code, Rock doesn't need this, since FireEngine.i got set in the WaterTankSearcher2.lua script already
		theFireman.FireEngine.i = this.Id.i
		theFireman.FireEngine.u = this.Id.u
		for obj in next, Object.GetNearbyObjects(this,"HoseXY",4) do
			if obj.TankUID ~= nil and obj.TankUID == this.Id.u and obj.Nr == theNr then
				print("Deleting HoseXY nr "..theNr)
				obj.Delete()
			end
		end
		-- finish PA 2018 code
		
		Set(this,"SwapGuy"..theNr.."Done",true)
		Set(this,"Fireman"..theNr.."Deployed",true)
	elseif Get(this,"GrabHose"..theNr.."Done") == false then
		print("fireman "..theNr.." not deployed yet, issue job GrabHose"..theNr)
		if		 theNr == 1 and Member1.Energy ~= nil then Member1.NavigateTo(this.Pos.x,this.Pos.y)
		elseif	 theNr == 2 and Member2.Energy ~= nil then Member2.NavigateTo(this.Pos.x,this.Pos.y)
		elseif	 theNr == 3 and Member3.Energy ~= nil then Member3.NavigateTo(this.Pos.x,this.Pos.y)
		elseif	 theNr == 4 and Member4.Energy ~= nil then Member4.NavigateTo(this.Pos.x,this.Pos.y); Object.CancelJob(this,"InspectWaterTankT"..this.Team.."M4")
		end	
		Object.CreateJob(this,"GrabHoseT"..this.Team.."M"..theNr)
	end
end

function SwapGuys(theFireman,theNr)	-- hide the Prison Fireman, since he can't do what real firemen can do, so we swap him out with the original one and start doing business afterwards
	print("function SwapGuys "..theNr)
	local GuysDoingTheJob = this.GetNearbyObjects("PrisonFiremanT"..this.Team.."M"..theNr,9)
	if next(GuysDoingTheJob) then
		for thatGuy, dist in pairs(GuysDoingTheJob) do
			if Get(this,"Member"..theNr.."ID") == thatGuy.Id.u then		-- check if he is my Prison fireman, or someone else's. allow only my Prison firemen to complete a job
				local tmpLockerID = Get(thatGuy,"FiremanLockerID")
				local tmpDamage = Get(thatGuy,"Damage")
				local tmpEnergy = Get(thatGuy,"Energy")
				
				Set(this,"Slot"..(theNr+3)..".i",thatGuy.Id.i)	-- first load this prison fireman beneath the tank
				Set(this,"Slot"..(theNr+3)..".u",thatGuy.Id.u)
				Set(thatGuy,"CarrierId.i",this.Id.i)
				Set(thatGuy,"CarrierId.u",this.Id.u)
				Set(thatGuy,"Loaded",true)
				Set(thatGuy,"Hidden",true)
				Set(thatGuy,"PutBeneathLocker",true)			-- sends a signal to the Chief to hide this guy beneath his locker
				
				local AvailableHoses = this.GetNearbyObjects("HoseIcon",2)
				for thatHose, dist in pairs(AvailableHoses) do
					if thatHose.HoseNr == theNr then
						thatHose.Delete()
					end
				end
				
				Set(this,"Slot"..(theNr-1)..".i",-1)
				Set(this,"Slot"..(theNr-1)..".u",-1)
				
				-- start PA 2018 code
				if	   theNr == 1 then Set(Fireman1,"CarrierId.i",-1);	Set(Fireman1,"CarrierId.u",-1); Set(Fireman1,"Loaded",false); Set(Fireman1,"Hidden",false); local tmpHoseObj = Object.Spawn("HoseXY",this.Pos.x+1.75,this.Pos.y+2.5); Set(tmpHoseObj,"TankUID",this.Id.u); Set(tmpHoseObj,"Nr",1); Fireman1.FireEngine.i = tmpHoseObj.Id.i; Fireman1.FireEngine.u = tmpHoseObj.Id.u;
				elseif theNr == 2 then Set(Fireman2,"CarrierId.i",-1);	Set(Fireman2,"CarrierId.u",-1); Set(Fireman2,"Loaded",false); Set(Fireman2,"Hidden",false); local tmpHoseObj = Object.Spawn("HoseXY",this.Pos.x+1.75,this.Pos.y+2.5); Set(tmpHoseObj,"TankUID",this.Id.u); Set(tmpHoseObj,"Nr",2); Fireman2.FireEngine.i = tmpHoseObj.Id.i; Fireman2.FireEngine.u = tmpHoseObj.Id.u;
				elseif theNr == 3 then Set(Fireman3,"CarrierId.i",-1);	Set(Fireman3,"CarrierId.u",-1); Set(Fireman3,"Loaded",false); Set(Fireman3,"Hidden",false); local tmpHoseObj = Object.Spawn("HoseXY",this.Pos.x+1.75,this.Pos.y+2.5); Set(tmpHoseObj,"TankUID",this.Id.u); Set(tmpHoseObj,"Nr",3); Fireman3.FireEngine.i = tmpHoseObj.Id.i; Fireman3.FireEngine.u = tmpHoseObj.Id.u;
				elseif theNr == 4 then Set(Fireman4,"CarrierId.i",-1);	Set(Fireman4,"CarrierId.u",-1); Set(Fireman4,"Loaded",false); Set(Fireman4,"Hidden",false); local tmpHoseObj = Object.Spawn("HoseXY",this.Pos.x+1.75,this.Pos.y+2.5); Set(tmpHoseObj,"TankUID",this.Id.u); Set(tmpHoseObj,"Nr",4); Fireman4.FireEngine.i = tmpHoseObj.Id.i; Fireman4.FireEngine.u = tmpHoseObj.Id.u;
				end
				-- finish PA 2018 code
				
				-- start PA Rock code
				-- if	   theNr == 1 then Set(Fireman1,"CarrierId.i",-1);	Set(Fireman1,"CarrierId.u",-1); Set(Fireman1,"Loaded",false); Set(Fireman1,"Hidden",false)
				-- elseif theNr == 2 then Set(Fireman2,"CarrierId.i",-1);	Set(Fireman2,"CarrierId.u",-1); Set(Fireman2,"Loaded",false); Set(Fireman2,"Hidden",false)
				-- elseif theNr == 3 then Set(Fireman3,"CarrierId.i",-1);	Set(Fireman3,"CarrierId.u",-1); Set(Fireman3,"Loaded",false); Set(Fireman3,"Hidden",false)
				-- elseif theNr == 4 then Set(Fireman4,"CarrierId.i",-1);	Set(Fireman4,"CarrierId.u",-1); Set(Fireman4,"Loaded",false); Set(Fireman4,"Hidden",false)
				-- end
				-- finish PA Rock code
				
				Set(this,"Fireman"..theNr.."Available",false)
				Set(this,"Member"..theNr.."ID","None")
				Set(this,"SwapGuy"..theNr.."Done",false)
				Set(this,"GrabHose"..theNr.."Done",true)
				Set(this,"CheckForReturningFiremen",true)
				timeFireCheck = timePerFireCheck-2
				Set(this,"FiremanBack",nil)

				if theNr == 4 and this.AutoManual == "-MANUAL-" then
					Set(this,"AutoManual","AUTO")
					this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
				end	-- when the crew manager is available, the WaterTank will change to AUTO mode if the tank was set to -MANUAL- due to prior fireman being KIA

									-- revive fireman if he was killed in action and a new fireman grabs a hose, or just unload him when a Prison fireman grabbed a hose
				-- start PA 2018 code
				if		 theNr == 1 then Set(Fireman1,"FiremanLockerID",tmpLockerID); Fireman1.Damage = tmpDamage; Fireman1.Energy = tmpEnergy; Fireman1.SubType = 0; Fireman1.Equipment = 24; Fireman1.ClearRouting(); Fireman1.NavigateTo(this.Pos.x-1.15,this.Pos.y-1.15); Fireman1.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",1,"M","Firefighter","R" }
				elseif	 theNr == 2 then Set(Fireman2,"FiremanLockerID",tmpLockerID); Fireman2.Damage = tmpDamage; Fireman2.Energy = tmpEnergy; Fireman2.SubType = 0; Fireman2.Equipment = 24; Fireman2.ClearRouting(); Fireman2.NavigateTo(this.Pos.x+1.15,this.Pos.y-1.15); Fireman2.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",2,"M","Firefighter","R" }
				elseif	 theNr == 3 then Set(Fireman3,"FiremanLockerID",tmpLockerID); Fireman3.Damage = tmpDamage; Fireman3.Energy = tmpEnergy; Fireman3.SubType = 0; Fireman3.Equipment = 24; Fireman3.ClearRouting(); Fireman3.NavigateTo(this.Pos.x-1.15,this.Pos.y+1.15); Fireman3.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",3,"M","Firefighter","R" }
				elseif	 theNr == 4 then Set(Fireman4,"FiremanLockerID",tmpLockerID); Fireman4.Damage = tmpDamage; Fireman4.Energy = tmpEnergy; Fireman4.SubType = 2; Fireman4.Equipment = 24; Fireman4.ClearRouting(); Fireman4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15); Fireman4.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",4,"M","Crew Manager","R" }
				end
				-- finish PA 2018 code
				
				-- start PA Rock code
				-- if		 theNr == 1 then Set(Fireman1,"FiremanLockerID",tmpLockerID); Fireman1.Damage = tmpDamage; Fireman1.Energy = tmpEnergy; Fireman1.SubType = 0; Fireman1.Equipment = 24; Fireman1.ClearRouting(); Fireman1.PlayerOrderPos.x = this.Pos.x-1.15; Fireman1.PlayerOrderPos.y = this.Pos.y-1.15; Fireman1.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",1,"M","Firefighter","R" }
				-- elseif	 theNr == 2 then Set(Fireman2,"FiremanLockerID",tmpLockerID); Fireman2.Damage = tmpDamage; Fireman2.Energy = tmpEnergy; Fireman2.SubType = 0; Fireman2.Equipment = 24; Fireman2.ClearRouting(); Fireman2.PlayerOrderPos.x = this.Pos.x+1.15; Fireman2.PlayerOrderPos.y = this.Pos.y-1.15; Fireman2.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",2,"M","Firefighter","R" }
				-- elseif	 theNr == 3 then Set(Fireman3,"FiremanLockerID",tmpLockerID); Fireman3.Damage = tmpDamage; Fireman3.Energy = tmpEnergy; Fireman3.SubType = 0; Fireman3.Equipment = 24; Fireman3.ClearRouting(); Fireman3.PlayerOrderPos.x = this.Pos.x-1.15; Fireman3.PlayerOrderPos.y = this.Pos.y+1.15; Fireman3.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",3,"M","Firefighter","R" }
				-- elseif	 theNr == 4 then Set(Fireman4,"FiremanLockerID",tmpLockerID); Fireman4.Damage = tmpDamage; Fireman4.Energy = tmpEnergy; Fireman4.SubType = 2; Fireman4.Equipment = 24; Fireman4.ClearRouting(); Fireman4.PlayerOrderPos.x = this.Pos.x+1.15; Fireman4.PlayerOrderPos.y = this.Pos.y+1.15; Fireman4.Tooltip = { "tooltip_RealFiremanActive",this.HomeUID,"W",TeamChar[this.Team],"T",4,"M","Crew Manager","R" }
				-- end
				-- finish PA Rock code
				break
			end
		end
	else
		Object.CreateJob(this,"GrabHoseT"..this.Team.."M"..theNr)
	end
end

function CheckReturningFireman(theFireman,theNr)	-- checks for returning firemen and spawns a Prison Fireman once the real fireman is back and deleted
	if Get(this,"GrabHose"..theNr.."Done") == true then
		if theFireman.Energy ~= nil and theFireman.Damage < 0.85 then	-- fireman not killed in action
			if theFireman.Loaded or theFireman.LeavingMap then									-- fires gone, fireman is back at the WaterTank, replace him with a normal Prison fireman
				local tmpLockerID = Get(theFireman,"FiremanLockerID")
				local tmpDamage = Get(theFireman,"Damage")
				local tmpEnergy = Get(theFireman,"Energy")
				Set(theFireman,"CarrierId.i",-1)
				Set(theFireman,"CarrierId.u",-1)
				Set(theFireman,"Loaded",false)
				print("fireman"..theNr.." is back")
				if Get(this,"Fireman"..theNr.."BackOrDead") == false then Set(this,"ReturningFiremanNr",this.ReturningFiremanNr + 1) end
				theFireman.IsPrisonFireman = nil
				Set(this,"Fireman"..theNr.."BackOrDead",true)
				theFireman.Delete()
				theFireman = ""
				
				if theNr == 1 then Set(Member1,"Energy",tmpEnergy); Set(Member1,"Damage",tmpDamage); Set(Member1,"FinishedAfterFire",true); Set(this,"Member1ID",Member1.Id.u) end
				if theNr == 2 then Set(Member2,"Energy",tmpEnergy); Set(Member2,"Damage",tmpDamage); Set(Member2,"FinishedAfterFire",true); Set(this,"Member2ID",Member2.Id.u) end
				if theNr == 3 then Set(Member3,"Energy",tmpEnergy); Set(Member3,"Damage",tmpDamage); Set(Member3,"FinishedAfterFire",true); Set(this,"Member3ID",Member3.Id.u) end
				if theNr == 4 then Set(Member4,"Energy",tmpEnergy); Set(Member4,"Damage",tmpDamage); Set(Member4,"FinishedAfterFire",true); Set(this,"Member4ID",Member4.Id.u) end
				
				Set(this,"Fireman"..theNr.."ID","None")
			else				
				if this.NoFiresFound == true and theFireman.Pos.x >= this.Pos.x-0.75 and theFireman.Pos.x <= this.Pos.x+0.75 and theFireman.Pos.y >= this.Pos.y-0.75 and theFireman.Pos.y <= this.Pos.y+0.75 then
					Set(this,"Slot"..(theNr-1)..".i",theFireman.Id.i)
					Set(this,"Slot"..(theNr-1)..".u",theFireman.Id.u)
					Set(theFireman,"CarrierId.i",this.Id.i)
					Set(theFireman,"CarrierId.u",this.Id.u)
					theFireman.Loaded = true
				elseif this.NoFiresFound == true and this.AutoManual == "AUTO" then		-- fires gone, fireman is walking back to the WaterTank
					-- start PA 2018 code
					if		 theNr == 1 then Fireman1.NavigateTo(this.Pos.x,this.Pos.y)
					elseif	 theNr == 2 then Fireman2.NavigateTo(this.Pos.x,this.Pos.y)
					elseif	 theNr == 3 then Fireman3.NavigateTo(this.Pos.x,this.Pos.y)
					elseif	 theNr == 4 then Fireman4.NavigateTo(this.Pos.x,this.Pos.y)
					end
					-- finish PA 2018 code
					
					-- start PA Rock code
					-- if		 theNr == 1 then Fireman1.PlayerOrderPos.x = this.Pos.x;	Fireman1.PlayerOrderPos.y = this.Pos.y
					-- elseif	 theNr == 2 then Fireman2.PlayerOrderPos.x = this.Pos.x;	Fireman2.PlayerOrderPos.y = this.Pos.y
					-- elseif	 theNr == 3 then Fireman3.PlayerOrderPos.x = this.Pos.x;	Fireman3.PlayerOrderPos.y = this.Pos.y
					-- elseif	 theNr == 4 then Fireman4.PlayerOrderPos.x = this.Pos.x;	Fireman4.PlayerOrderPos.y = this.Pos.y
					-- end
					-- finish PA Rock code
				end
			end
		else		-- fireman killed in action, replace with a dead dummy, zap fireman back to the WaterTank, so a fresh hired Prison fireman can grab a new hose
			if Get(this,"Fireman"..theNr.."BackOrDead") == false then Set(this,"DeadFiremanNr",this.DeadFiremanNr + 1) end
			print("+++++++++++++++++++ fireman"..theNr.." is dead")
			deadFireman = Object.Spawn("Fireman",theFireman.Pos.x,theFireman.Pos.y)
			deadFireman.Equipment = 0
			deadFireman.Tooltip = "Toasted bogey"
			deadFireman.Damage = 1
			theFireman.Equipment = 0
			if theNr == 4 then deadFireman.SubType = 3 else deadFireman.SubType = 1 end -- dead crew manager or normal fireman?
			theFireman.SubType = 4		--hide
			
			local hoseOffset = 0.05
			if theNr == 2 then hoseOffset = 0.15 elseif theNr == 3 then hoseOffset = 0.25 elseif theNr == 4 then hoseOffset = 0.35 end
			local newHose = Object.Spawn("HoseIcon",this.Pos.x+hoseOffset,this.Pos.y+0.25)
			Set(newHose,"HoseNr",theNr)
			
			Set(theFireman,"CarrierId.i",this.Id.i)
			Set(theFireman,"CarrierId.u",this.Id.u)
			Set(this,"Slot"..(theNr-1)..".i",theFireman.Id.i)
			Set(this,"Slot"..(theNr-1)..".u",theFireman.Id.u)
			Set(theFireman,"Loaded",true)
			Set(theFireman,"Hidden",true)
			Set(theFireman,"Damage",0)
			Set(theFireman,"Energy",100)
			theFireman.Tooltip = "tooltip_RealFiremanQueued"
			
			if theNr == 1 then Set(Member1,"ReviveFromLocker",true) end
			if theNr == 2 then Set(Member2,"ReviveFromLocker",true) end
			if theNr == 3 then Set(Member3,"ReviveFromLocker",true) end
			if theNr == 4 then Set(Member4,"ReviveFromLocker",true) end
			
			if theNr == 4 and this.AutoManual == "AUTO" then
				Set(this,"AutoManual","-MANUAL-") 
				this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
			end
			Set(this,"Member"..theNr.."ID","None")
			Set(this,"Fireman"..theNr.."Available",true)
			Set(this,"Fireman"..theNr.."Deployed",false)
			Set(this,"GrabHose"..theNr.."Done",false)
			Set(this,"SwapGuy"..theNr.."Done",false)
			Set(this,"TeamMembers",this.TeamMembers-1)
			Set(this,"Fireman"..theNr.."BackOrDead",true)
		end
	end
end

function CheckIfFiresAreGone()	-- scans every ~8 game minutes for new fires, but only if all currently known fires are gone
	print("....function CheckIfFiresAreGone....")	-- should make this function smaller but it works so why bother
	if not this.StopScanningForFire then
---------------find nearest fires first to start with-------------------------------
		if fireNumber == 0 and not this.TLwholeDone and not this.TRwholeDone and not this.BLwholeDone and not this.BRwholeDone then
			fireNumber = 0
			print("Global: Search request for initial fresh fires within a quarter of my range...")
			allFires = Find("Fire",FireScanRange*0.25) 
			for thatFire, dist in pairs(allFires) do
				fireNumber = fireNumber+1
			end
			if fireNumber <= 1 then
				fireNumber = 0
				print("Global: Area clear")
				print("Global: Search request for initial fresh fires within half my range...")
				allFires = Find("Fire",FireScanRange*0.50) 
				for thatFire, dist in pairs(allFires) do
					fireNumber = fireNumber+1
				end
				if fireNumber <= 1 then
					fireNumber = 0
					print("Global: Area clear")
					print("Global: Search request for initial fresh fires within three quarters of my range...")
					allFires = Find("Fire",FireScanRange*0.75) 
					for thatFire, dist in pairs(allFires) do
						fireNumber = fireNumber+1
					end
					if fireNumber <= 1 then
						fireNumber = 0
						print("Global: Area clear")
						print("Global: Search request for initial fresh fires within my whole range...")
						allFires = Find("Fire",FireScanRange) 
						for thatFire, dist in pairs(allFires) do
							fireNumber = fireNumber+1
						end
					end
				end
			end
		else
		---------------topleft fires check-------------------------------		
			if fireTLNumber <= 1 and this.Fireman1Request == true then
				if not this.TLquarterDone then
					fireTLNumber = 0
					print("Fireman1: Search request for fresh fires within a quarter of TopLeft range...")
					topLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.0625),this.Pos.y-(FireScanRange*0.0625))
				--	ShowCoveredArea(topLeft,FireScanRange*0.125,"FiremanTL")		-- just for testing, this eats way too much cpu power to enable it by default
					firesTopLeft = FindFrom(topLeft,"Fire",FireScanRange*0.125)
					for thatFire, dist in pairs(firesTopLeft) do
						fireTLNumber = fireTLNumber+1
					end
					Set(this,"TLquarterDone",true)
				end
				if fireTLNumber <= 1 and not this.TLhalfDone then
					fireTLNumber = 0
					print("Fireman1: Search request for fresh fires within half my TopLeft range...")
					topLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.125),this.Pos.y-(FireScanRange*0.125))
				--	ShowCoveredArea(topLeft,FireScanRange*0.25,"FiremanTL")
					firesTopLeft = FindFrom(topLeft,"Fire",FireScanRange*0.25)
					for thatFire, dist in pairs(firesTopLeft) do
						fireTLNumber = fireTLNumber+1
					end
					Set(this,"TLhalfDone",true)
				end
				if fireTLNumber <= 1 and not this.TLthreequarterDone then
					fireTLNumber = 0
					print("Fireman1: Search request for fresh fires within three quarters of my TopLeft range...")
					topLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.1875),this.Pos.y-(FireScanRange*0.1875))
				--	ShowCoveredArea(topLeft,FireScanRange*0.375,"FiremanTL")
					firesTopLeft = FindFrom(topLeft,"Fire",FireScanRange*0.375)
					for thatFire, dist in pairs(firesTopLeft) do
						fireTLNumber = fireTLNumber+1
					end
					Set(this,"TLthreequarterDone",true)
				end
				if fireTLNumber <= 1 and not this.TLwholeDone then
					fireTLNumber = 0
					print("Fireman1: Search request for fresh fires within my whole TopLeft range...")
					topLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.25),this.Pos.y-(FireScanRange*0.25))
				--	ShowCoveredArea(topLeft,FireScanRange*0.5,"FiremanTL")
					firesTopLeft = FindFrom(topLeft,"Fire",FireScanRange*0.5)
					for thatFire, dist in pairs(firesTopLeft) do
						fireTLNumber = fireTLNumber+1
					end
					Set(this,"TLwholeDone",true)
				end
				Set(this,"Fireman1Request",false)
				if fireTLNumber > 0 and this.Fireman1ID ~= "None" and this.GrabHose1Done == true then
					print("Fireman1: Local fire detected, navigating to new position")
					NavigateToNearestFire(Fireman1,0,allFires,firesTopLeft)
					if this.Fireman2Request == true or this.Fireman3Request == true or this.Fireman4Request == true then
						timeFireCheck = timePerFireCheck
					end
					print("TL: "..fireTLNumber.."   TR: "..fireTRNumber.."   BL: "..fireBLNumber.."   BR: "..fireBRNumber.."   All: "..fireNumber)
					return
				end
			end
		---------------topright fires check-------------------------------	
			if fireTRNumber <= 1 and this.Fireman2Request == true then
				if not this.TRquarterDone then
					fireTRNumber = 0
					print("Fireman2: Search request for fresh fires within a quarter of TopRight range...")
					topRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.0625),this.Pos.y-(FireScanRange*0.0625))
				--	ShowCoveredArea(topRight,FireScanRange*0.125,"FiremanTR")
					firesTopRight = FindFrom(topRight,"Fire",FireScanRange*0.125)
					for thatFire, dist in pairs(firesTopRight) do
						fireTRNumber = fireTRNumber+1
					end
					Set(this,"TRquarterDone",true)
				end
				if fireTRNumber <= 1 and not this.TRhalfDone then
					fireTRNumber = 0
					print("Fireman2: Search request for fresh fires within half my TopRight range...")
					topRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.125),this.Pos.y-(FireScanRange*0.125))
				--	ShowCoveredArea(topRight,FireScanRange*0.25,"FiremanTR")
					firesTopRight = FindFrom(topRight,"Fire",FireScanRange*0.25)
					for thatFire, dist in pairs(firesTopRight) do
						fireTRNumber = fireTRNumber+1
					end
					Set(this,"TRhalfDone",true)
				end
				if fireTRNumber <= 1 and not this.TRthreequarterDone then
					fireTRNumber = 0
					print("Fireman2: Search request for fresh fires within three quarters of my TopRight range...")
					topRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.1875),this.Pos.y-(FireScanRange*0.1875))
				--	ShowCoveredArea(topRight,FireScanRange*0.375,"FiremanTR")
					firesTopRight = FindFrom(topRight,"Fire",FireScanRange*0.375)
					for thatFire, dist in pairs(firesTopRight) do
						fireTRNumber = fireTRNumber+1
					end
					Set(this,"TRthreequarterDone",true)
				end
				if fireTRNumber <= 1 and not this.TRwholeDone then
					fireTRNumber = 0
					print("Fireman2: Search request for fresh fires within my whole TopRight range...")
					topRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.25),this.Pos.y-(FireScanRange*0.25))
				--	ShowCoveredArea(topRight,FireScanRange*0.5,"FiremanTR")
					firesTopRight = FindFrom(topRight,"Fire",FireScanRange*0.5)
					for thatFire, dist in pairs(firesTopRight) do
						fireTRNumber = fireTRNumber+1
					end
					Set(this,"TRwholeDone",true)
				end
				Set(this,"Fireman2Request",false)
				if fireTRNumber > 0 and this.Fireman2ID ~= "None" and this.GrabHose2Done == true then
					print("Fireman2: Local fire detected, navigating to new position")
					NavigateToNearestFire(Fireman2,1,allFires,firesTopRight)
					if this.Fireman1Request == true or this.Fireman3Request == true or this.Fireman4Request == true then
						timeFireCheck = timePerFireCheck
					end
					print("TL: "..fireTLNumber.."   TR: "..fireTRNumber.."   BL: "..fireBLNumber.."   BR: "..fireBRNumber.."   All: "..fireNumber)
					return
				end
			end
		---------------bottomleft fires check-------------------------------	
			if  fireBLNumber <= 1 and this.Fireman3Request == true then
				if not this.BLquarterDone then
					fireBLNumber = 0
					print("Fireman3: Search request for fresh fires within a quarter of BottomLeft range...")
					bottomLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.0625),this.Pos.y+(FireScanRange*0.0625))
				--	ShowCoveredArea(bottomLeft,FireScanRange*0.125,"FiremanBL")
					firesBottomLeft = FindFrom(bottomLeft,"Fire",FireScanRange*0.125)
					for thatFire, dist in pairs(firesBottomLeft) do
						fireBLNumber = fireBLNumber+1
					end
					Set(this,"BLquarterDone",true)
				end
				if fireBLNumber <= 1 and not this.BLhalfDone then
					fireBLNumber = 0
					print("Fireman3: Search request for fresh fires within half my BottomLeft range...")
					bottomLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.125),this.Pos.y+(FireScanRange*0.125))
				--	ShowCoveredArea(bottomLeft,FireScanRange*0.25,"FiremanBL")
					firesBottomLeft = FindFrom(bottomLeft,"Fire",FireScanRange*0.25)
					for thatFire, dist in pairs(firesBottomLeft) do
						fireBLNumber = fireBLNumber+1
					end
					Set(this,"BLhalfDone",true)
				end
				if fireBLNumber <= 1 and not this.BLthreequarterDone then
					fireBLNumber = 0
					print("Fireman3: Search request for fresh fires within three quarters of my BottomLeft range...")
					bottomLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.1875),this.Pos.y+(FireScanRange*0.1875))
				--	ShowCoveredArea(bottomLeft,FireScanRange*0.375,"FiremanBL")
					firesBottomLeft = FindFrom(bottomLeft,"Fire",FireScanRange*0.375)
					for thatFire, dist in pairs(firesBottomLeft) do
						fireBLNumber = fireBLNumber+1
					end
					Set(this,"BLthreequarterDone",true)
				end
				if fireBLNumber <= 1 and not this.BLwholeDone then
					fireBLNumber = 0
					print("Fireman3: Search request for fresh fires within my whole BottomLeft range...")
					bottomLeft = Object.Spawn("FiremanAreaCovered",this.Pos.x-(FireScanRange*0.25),this.Pos.y+(FireScanRange*0.25))
				--	ShowCoveredArea(bottomLeft,FireScanRange*0.5,"FiremanBL")
					firesBottomLeft = FindFrom(bottomLeft,"Fire",FireScanRange*0.5)
					for thatFire, dist in pairs(firesBottomLeft) do
						fireBLNumber = fireBLNumber+1
					end
					Set(this,"BLwholeDone",true)
				end
				Set(this,"Fireman3Request",false)
				if fireBLNumber > 0 and this.Fireman3ID ~= "None" and this.GrabHose3Done == true then
					print("Fireman3: Local fire detected, navigating to new position")
					NavigateToNearestFire(Fireman3,2,allFires,firesBottomLeft)
					if this.Fireman1Request == true or this.Fireman2Request == true or this.Fireman4Request == true then
						timeFireCheck = timePerFireCheck
					end
					print("TL: "..fireTLNumber.."   TR: "..fireTRNumber.."   BL: "..fireBLNumber.."   BR: "..fireBRNumber.."   All: "..fireNumber)
					return
				end
			end
		---------------bottomright fires check-------------------------------	
			if fireBRNumber <= 1 and this.Fireman4Request == true then
				if not this.BRquarterDone then
					fireBRNumber = 0
					print("Fireman4: Search request for fresh fires within a quarter of BottomRight range...")
					bottomRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.0625),this.Pos.y+(FireScanRange*0.0625))
				--	ShowCoveredArea(bottomRight,FireScanRange*0.125,"FiremanBR")
					firesBottomRight = FindFrom(bottomRight,"Fire",FireScanRange*0.125)
					for thatFire, dist in pairs(firesBottomRight) do
						fireBRNumber = fireBRNumber+1
					end
					Set(this,"BRquarterDone",true)
				end
				if fireBRNumber <= 1 and not this.BRhalfDone then
					fireBRNumber = 0
					print("Fireman4: Search request for fresh fires within half my BottomRight range...")
					bottomRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.125),this.Pos.y+(FireScanRange*0.125))
				--	ShowCoveredArea(bottomRight,FireScanRange*0.25,"FiremanBR")
					firesBottomRight = FindFrom(bottomRight,"Fire",FireScanRange*0.25)
					for thatFire, dist in pairs(firesBottomRight) do
						fireBRNumber = fireBRNumber+1
					end
					Set(this,"BRhalfDone",true)
				end
				if fireBRNumber <= 1 and not this.BRthreequarterDone then
					fireBRNumber = 0
					print("Fireman4: Search request for fresh fires within three quarters of my BottomRight range...")
					bottomRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.1875),this.Pos.y+(FireScanRange*0.1875))
				--	ShowCoveredArea(bottomRight,FireScanRange*0.375,"FiremanBR")
					firesBottomRight = FindFrom(bottomRight,"Fire",FireScanRange*0.375)
					for thatFire, dist in pairs(firesBottomRight) do
						fireBRNumber = fireBRNumber+1
					end
					Set(this,"BRthreequarterDone",true)
				end
				if fireBRNumber <= 1 and not this.BRwholeDone then
					fireBRNumber = 0
					print("Fireman4: Search request for fresh fires within my whole BottomRight range...")
					bottomRight = Object.Spawn("FiremanAreaCovered",this.Pos.x+(FireScanRange*0.25),this.Pos.y+(FireScanRange*0.25))
				--	ShowCoveredArea(bottomRight,FireScanRange*0.5,"FiremanBR")
					firesBottomRight = FindFrom(bottomRight,"Fire",FireScanRange*0.5)
					for thatFire, dist in pairs(firesBottomRight) do
						fireBRNumber = fireBRNumber+1
					end
					Set(this,"BRwholeDone",true)
				end
				Set(this,"Fireman4Request",false)
				if fireBRNumber > 0 and this.Fireman4ID ~= "None" and this.GrabHose4Done == true then
					print("Fireman4: Local fire detected, navigating to new position")
					NavigateToNearestFire(Fireman4,3,allFires,firesBottomRight)
					if this.Fireman1Request == true or this.Fireman2Request == true or this.Fireman3Request == true then
						timeFireCheck = timePerFireCheck
					end
					print("TL: "..fireTLNumber.."   TR: "..fireTRNumber.."   BL: "..fireBLNumber.."   BR: "..fireBRNumber.."   All: "..fireNumber)
					return
				end
			end
	---------------all fires check-------------------------------
			if fireNumber <= 1 and (this.TLwholeDone == true or this.TRwholeDone == true or this.BLwholeDone == true or this.BRwholeDone == true) then
				fireNumber = 0
				print("Global: Search request for fresh fires within a quarter of my range...")
				allFires = Find("Fire",FireScanRange*0.25) 
				for thatFire, dist in pairs(allFires) do
					fireNumber = fireNumber+1
				end
				if fireNumber <= 1 then
					fireNumber = 0
					print("Global: Area clear")
					print("Global: Search request for fresh fires within half my range...")
					allFires = Find("Fire",FireScanRange*0.50) 
					for thatFire, dist in pairs(allFires) do
						fireNumber = fireNumber+1
					end
					if fireNumber <= 1 then
						fireNumber = 0
						print("Global: Area clear")
						print("Global: Search request for fresh fires within three quarters of my range...")
						allFires = Find("Fire",FireScanRange*0.75) 
						for thatFire, dist in pairs(allFires) do
							fireNumber = fireNumber+1
						end
						if fireNumber <= 1 then
							fireNumber = 0
							print("Global: Area clear")
							print("Global: Search request for fresh fires within my whole range...")
							allFires = Find("Fire",FireScanRange) 
							for thatFire, dist in pairs(allFires) do
								fireNumber = fireNumber+1
							end
						end
					end
				end
			end
			print("TL: "..fireTLNumber.."   TR: "..fireTRNumber.."   BL: "..fireBLNumber.."   BR: "..fireBRNumber.."   All: "..fireNumber)
		end
		if fireTLNumber > 0 or fireTRNumber > 0 or fireBLNumber > 0 or fireBRNumber > 0 or fireNumber > 0 then
			timePerUpdate = 2+math.random() / myTimeWarpFactor
			Set(this,"NoFiresFound",false)
			print("Global: Fire detected, navigating all firemen to new position")
			if this.Fireman1ID ~= "None" and this.GrabHose1Done == true then NavigateToNearestFire(Fireman1,1,allFires,firesTopLeft) end
			if this.Fireman2ID ~= "None" and this.GrabHose2Done == true then NavigateToNearestFire(Fireman2,2,allFires,firesTopRight) end
			if this.Fireman3ID ~= "None" and this.GrabHose3Done == true then NavigateToNearestFire(Fireman3,3,allFires,firesBottomLeft) end
			if this.Fireman4ID ~= "None" and this.GrabHose4Done == true then NavigateToNearestFire(Fireman4,4,allFires,firesBottomRight) end
		else
			print("Global: Area clear")
			print("Global: No more fires found within range, returning all firemen")
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M1")	-- cancel any pending jobs, they are no longer needed
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M2")
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M3")
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M4")
			timePerUpdate = 1+math.random() / myTimeWarpFactor
			Set(this,"NoFiresFound",true)
			Set(this,"StopScanningForFire",true)
			
			-- start PA 2018 code
			if this.Fireman1ID ~= "None" and this.GrabHose1Done == true then Fireman1.NavigateTo(this.Pos.x-1.15,this.Pos.y-1.15) end
			if this.Fireman2ID ~= "None" and this.GrabHose2Done == true then Fireman2.NavigateTo(this.Pos.x+1.15,this.Pos.y-1.15) end
			if this.Fireman3ID ~= "None" and this.GrabHose3Done == true then Fireman3.NavigateTo(this.Pos.x-1.15,this.Pos.y+1.15) end
			if this.Fireman4ID ~= "None" and this.GrabHose4Done == true then Fireman4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15) end
			-- finish PA 2018 code
			
			-- start PA Rock code
			-- if this.Fireman1ID ~= "None" and this.GrabHose1Done == true then Fireman1.PlayerOrderPos.x = this.Pos.x-1.15;	Fireman1.PlayerOrderPos.y = this.Pos.y-1.15 end
			-- if this.Fireman2ID ~= "None" and this.GrabHose2Done == true then Fireman2.PlayerOrderPos.x = this.Pos.x+1.15;	Fireman2.PlayerOrderPos.y = this.Pos.y-1.15 end
			-- if this.Fireman3ID ~= "None" and this.GrabHose3Done == true then Fireman3.PlayerOrderPos.x = this.Pos.x-1.15;	Fireman3.PlayerOrderPos.y = this.Pos.y+1.15 end
			-- if this.Fireman4ID ~= "None" and this.GrabHose4Done == true then Fireman4.PlayerOrderPos.x = this.Pos.x+1.15;	Fireman4.PlayerOrderPos.y = this.Pos.y+1.15 end
			-- finish PA Rock code
		end
	end
end

function NavigateToNearestFire(theEntity,theNr,allFires,localFires)	-- calculates which fire is nearest to the corresponding fireman, and sends him over there
	local Done = false
	local retryCounter = 0
	local rndFire = 0
	local CurrentDist = 10000
	local localFireNr = 0
	local theDistance = 0
	if theNr == 1 then localFireNr = fireTLNumber
	elseif theNr == 2 then localFireNr = fireTRNumber
	elseif theNr == 3 then localFireNr = fireBLNumber
	elseif theNr == 4 then localFireNr = fireBRNumber
	end
	while Done == false do
		if localFireNr > 0 then
			CurrentDist = 10000
			for thatFire, dist in pairs(localFires) do
				if thatFire.SubType == nil then
					localFires[thatFire] = nil
					localFireNr = localFireNr - 1
				--	print("localFireNr:"..localFireNr)
				else
					theDistance = FindDistance(theEntity.Pos.x,theEntity.Pos.y,thatFire.Pos.x,thatFire.Pos.y)
					if tonumber(theDistance) <= CurrentDist then
						CurrentDist = theDistance
						myFire = thatFire
						print("Fireman"..theNr..": Filtering nearest local fire: "..myFire.Pos.x.."   "..myFire.Pos.y.." distance: "..theDistance)
					end
				end
			end
			--print("localFireNr:"..localFireNr)
			--print("Sending fireman"..theNr.." to local fire: "..myFire.Pos.x.."   "..myFire.Pos.y.." distance: "..theDistance)
			if theNr == 1 then fireTLNumber = localFireNr
			elseif theNr == 2 then fireTRNumber = localFireNr
			elseif theNr == 3 then fireBLNumber = localFireNr
			elseif theNr == 4 then fireBRNumber = localFireNr
			end
			if localFireNr == 0 then
				print("Fireman"..theNr..": Area clear")
				print("Fireman"..theNr..": No dedicated local fires found, requesting new search at wider range")
				if theNr == 1 then Set(this,"Fireman1Request",true)
				elseif theNr == 2 then Set(this,"Fireman2Request",true)
				elseif theNr == 3 then Set(this,"Fireman3Request",true)
				elseif theNr == 4 then Set(this,"Fireman4Request",true)
				end
				Done = true
				return
			end
		else
		--	print("Fireman"..theNr..": Area clear")
		--	print("Fireman"..theNr..": No dedicated local fires found")
			if theNr == 1 then Set(this,"Fireman1Request",true); Fireman1.SubType = 1
			elseif theNr == 2 then Set(this,"Fireman2Request",true); Fireman2.SubType = 1
			elseif theNr == 3 then Set(this,"Fireman3Request",true); Fireman3.SubType = 1
			elseif theNr == 4 then Set(this,"Fireman4Request",true); Fireman4.SubType = 3
			end
			if fireNumber > 0 then
				CurrentDist = 10000
				for thatFire, dist in pairs(allFires) do
					if thatFire.SubType == nil then
						allFires[thatFire] = nil
						fireNumber = fireNumber-1
					--	print("fireNumber:"..fireNumber)
					else
						theDistance = FindDistance(theEntity.Pos.x,theEntity.Pos.y,thatFire.Pos.x,thatFire.Pos.y)
						if tonumber(theDistance) <= CurrentDist then
							CurrentDist = theDistance
							myFire = thatFire
							print("Fireman"..theNr..": Filtering nearest global fire "..myFire.Pos.x.."   "..myFire.Pos.y.." distance: "..theDistance)
						end
					end
				end
			--	print("fireNumber:"..fireNumber)
			--	print("Sending fireman"..theNr.." to global fire: "..myFire.Pos.x.."   "..myFire.Pos.y.." distance: "..theDistance)
			end
		end
		if myFire == nil then
			fireNumber = 0
			timeFireCheck = timePerFireCheck
			print("Fireman"..theNr..": Area clear")
			print("Fireman"..theNr..": No more known fires within range")
			Done = true
			return
		else
			local smk = 0; localSmoke = FindFrom(theEntity,"SmokeGenerator",12); for thatSmoke, dist in pairs(localSmoke) do smk = smk+1; thatSmoke.Delete(); end; print("smoke deleted: "..smk); localSmoke = nil	-- get rid of some nearby smoke since it slows down the game.
			Set(this,"NoFiresFound",false)	-- we have a fire, move the fireman to a spot close to it which is not a wall or water
			local moveToX = myFire.Pos.x
			local moveToY = myFire.Pos.y
			if this.Pos.x > moveToX then moveToX = moveToX+math.random(2,5) else moveToX = moveToX-math.random(2,5) end
			if this.Pos.y > moveToY then moveToY = moveToY+math.random(2,5) else moveToY = moveToY-math.random(2,5) end
			if moveToX < 1 then moveToX = 1 end
			if moveToY < 1 then moveToY = 1 end
			local tmpCell = World.GetCell(math.floor(moveToX),math.floor(moveToY))
			if tmpCell.Mat == "BrickWall" or tmpCell.Mat == "ConcreteWall" or tmpCell.Mat == "PerimeterWall" or tmpCell.Mat == "Fence" or tmpCell.Mat == "Water" then
		--		print("tmpCell.Mat: "..tmpCell.Mat..", retrying...")
				Done = false
			else
		--		print("covered spawned, moving entity to "..moveToX.." "..moveToY)
				local newCovered = Object.Spawn("FiremanTLAreaCovered",moveToX,moveToY)	-- spawn a little temporary indicator on the floor where the fireman will go to (it deletes itself again)
				print("Fireman"..theNr..": moving to x: "..moveToX.." y: "..moveToY)

				-- start PA 2018 code
				theEntity.NavigateTo(moveToX,moveToY)
				-- finish PA 2018 code
				
				-- start PA Rock code
				-- theEntity.PlayerOrderPos.x = moveToX
				-- theEntity.PlayerOrderPos.y = moveToY
				-- finish PA Rock code
				Done = true
			end
			myFire = nil
		end
		
		retryCounter = retryCounter+1			-- to prevent looping, we give this While 10 chances to find a suitable spot on the map to walk to
	--	print("retryCounter: "..retryCounter)
		if retryCounter >= 10 then
			print("FAIL")
			fireNumber = 0
			timeFireCheck = timePerFireCheck	-- when failed, the Firemen will walk counterclockwise around the WaterTank :)

			-- start PA 2018 code
			if		 theNr == 1 then theEntity.NavigateTo(this.Pos.x-1.15,this.Pos.y-1.15)
			elseif	 theNr == 2 then theEntity.NavigateTo(this.Pos.x+1.15,this.Pos.y-1.15)
			elseif	 theNr == 3 then theEntity.NavigateTo(this.Pos.x-1.15,this.Pos.y+1.15)
			elseif	 theNr == 4 then theEntity.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
			end
			-- finish PA 2018 code
			
			-- start PA Rock code
			-- if		 theNr == 1 then theEntity.PlayerOrderPos.x = this.Pos.x-1.15;	theEntity.PlayerOrderPos.y = this.Pos.y-1.15
			-- elseif	 theNr == 2 then theEntity.PlayerOrderPos.x = this.Pos.x+1.15;	theEntity.PlayerOrderPos.y = this.Pos.y-1.15
			-- elseif	 theNr == 3 then theEntity.PlayerOrderPos.x = this.Pos.x-1.15;	theEntity.PlayerOrderPos.y = this.Pos.y+1.15
			-- elseif	 theNr == 4 then theEntity.PlayerOrderPos.x = this.Pos.x+1.15;	theEntity.PlayerOrderPos.y = this.Pos.y+1.15
			-- end
			-- finish PA Rock code
			Done = true
		end
	end
end


function CheckMyMembers()
	print("Checking for TeamMembers")
	Member1 = ""
	Member2 = ""
	Member3 = ""
	Member4 = ""
	Member1 = Load(Member1,"PrisonFiremanT"..this.Team.."M1","Member1ID",10000); -- if this.Member1ID ~= "None" then Member1.Tooltip = { "tooltip_PrisonFireman"..this.Team.."0",this.HomeUID,"X" } end
	Member2 = Load(Member2,"PrisonFiremanT"..this.Team.."M2","Member2ID",10000); -- if this.Member2ID ~= "None" then Member2.Tooltip = { "tooltip_PrisonFireman"..this.Team.."1",this.HomeUID,"X" } end
	Member3 = Load(Member3,"PrisonFiremanT"..this.Team.."M3","Member3ID",10000); -- if this.Member3ID ~= "None" then Member3.Tooltip = { "tooltip_PrisonFireman"..this.Team.."2",this.HomeUID,"X" } end
	Member4 = Load(Member4,"PrisonFiremanT"..this.Team.."M4","Member4ID",10000); -- if this.Member4ID ~= "None" then Member4.Tooltip = { "tooltip_PrisonFireman"..this.Team.."3",this.HomeUID,"X" } end
	Set(this,"TeamMembers",0.0)
	for i=1,4 do
		if Get(this,"Member"..i.."ID") ~= "None" then
			Set(this,"TeamMembers",this.TeamMembers+1)
		end
	end
	if this.WaterTankBusy == true and this.AutoManual == "AUTO" then
		timeFireCheck = timePerFireCheck
	end
	if Get(this,"TeamMembers") > 0 then
		if buttonsAdded == false then
			Interface.AddComponent(this,"CaptionSeparatorWaterTank", "Caption", "tooltip_separatorAutoManual")
			Interface.AddComponent(this,"toggleAutoManual", "Button", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
			buttonsAdded = true
		else
			if Get(this,"TeamMembers") == 3 then
				if this.AutoManual == "AUTO" then
					Set(this,"AutoManual","-MANUAL-") 
					this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
				end
			else
				if Get(this,"TeamMembers") == 4 then
					if this.AutoManual == "-MANUAL-" then
						Set(this,"AutoManual","AUTO") 
						this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
					end
				end
				this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
			end
		end
	else
		if buttonsAdded == true then
			Interface.RemoveComponent(this,"CaptionSeparatorWaterTank", "Caption", "tooltip_separatorAutoManual")
			Interface.RemoveComponent(this,"toggleAutoManual", "Button", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
			buttonsAdded = false
		end
	end
	this.Tooltip = { "tooltip_WaterTank",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M" }
	Set(this,"CheckForNewMembers",false)
end

function ClearSurroundingFires()
	if not Get(this,"SurroundingFiresCleared") then
		local surroundingFires = Find("Fire",12)
		if next(surroundingFires) then
			for thatFire, dist in pairs(surroundingFires) do
				thatFire.Delete()
			end
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M1")	-- cancel the pending jobs, since they might have been Too Dangerous
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M2")	-- they get issued again by DeployFireman() anyway
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M3")
			Object.CancelJob(this,"GrabHoseT"..this.Team.."M4")
		end
		Set(this,"SurroundingFiresCleared",true)
	end
end

function CheckForFiresInRange()
	local NewFiresInRange = Find("Fire",FireScanRange) 
	if next(NewFiresInRange) then
		Set(this,"FiresInRangeDetected",true)
	else
		Set(this,"FiresInRangeDetected",nil)
	end
	NewFiresInRange = nil
end










-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 

function FindDistance(x, y, x2, y2)
  local dx, dy = x2 - x, y2 - y
  return math.sqrt(dx*dx + dy*dy)
end

function Find(theObject,theRange) -- returns target objects in a square around the object
	local Xmin=math.ceil(this.Pos.x-theRange/2)
	local Xmax=math.ceil(this.Pos.x+theRange/2)
	local Ymin=math.ceil(this.Pos.y-theRange/2)
	local Ymax=math.ceil(this.Pos.y+theRange/2)
	local ListOfObjects = this.GetNearbyObjects(theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function FindFrom(theSource,theObject,theRange)		 -- returns target objects in a square around the object
	local Xmin=math.ceil(theSource.Pos.x-theRange/2)
	local Xmax=math.ceil(theSource.Pos.x+theRange/2)
	local Ymin=math.ceil(theSource.Pos.y-theRange/2)
	local Ymax=math.ceil(theSource.Pos.y+theRange/2)
	local ListOfObjects = Object.GetNearbyObjects(theSource,theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	

function toggleShowCoveredFireAreaClicked()
--	if Covered==true then
--		HideCoveredArea("Fireman")
--		Covered=false
--	else
		ShowCoveredArea(this,FireScanRange,"Fireman")
--		Covered=true
--	end
end

--function HideCoveredArea(theCoverType)
--	for n,v in pairs(CoveredArea[theCoverType]) do
--		CoveredArea[theCoverType][n].Delete()
--	end
--	CoveredArea[theCoverType] = nil
--end

function ShowCoveredArea(theObject,theRange,theCoverType)
	local Xmin=math.ceil(theObject.Pos.x-theRange/2)
	local Xmax=math.ceil(theObject.Pos.x+theRange/2)
	local Ymin=math.ceil(theObject.Pos.y-theRange/2)
	local Ymax=math.ceil(theObject.Pos.y+theRange/2)
	local n=0
	local counter=0
	CoveredArea[theCoverType] = {}
	for i=Ymin,Ymax do
		counter = counter+1
		if counter == 9 then
			counter = 0
			CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmin,i)
			CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredFireArea"}
		end
		n=n+1
	end
	counter = 0
	for i=Xmin,Xmax do
		counter = counter+1
		if counter == 9 then
			counter = 0
			CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymin)
			CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredFireArea"}
		end
		n=n+1
	end
	counter = 0
	for i=Ymin,Ymax do
		counter = counter+1
		if counter == 9 then
			counter = 0
			CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",Xmax,i)
			CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredFireArea"}
		end
		n=n+1
	end
	counter = 0
	for i=Xmin,Xmax do
		counter = counter+1
		if counter == 9 then
			counter = 0
			CoveredArea[theCoverType][n] = Object.Spawn(theCoverType.."AreaCovered",i,Ymax)
			CoveredArea[theCoverType][n].Tooltip={"tooltip_CoveredFireArea"}
		end
		n=n+1
	end
end

--			AUTO, MANUAL = by user desired
--			AUTO, -MANUAL- = set by firemanlocker/prisonfireman.lua when team has or hasn't got a crew manager
-- 			when in -MANUAL- mode, user cannot switch back to AUTO: only when a new fireman is hired it will change back to AUTO, unless the tank was set to run in MANUAL mode by the user.
function toggleAutoManualClicked()
	if this.AutoManual == "AUTO" then
		Set(this,"AutoManual","MANUAL")
	elseif this.AutoManual == "MANUAL" then
		Set(this,"AutoManual","AUTO")
	end
	if this.WaterTankBusy == true and this.AutoManual == "AUTO" then
		timeFireCheck = timePerFireCheck
	end
	this.SetInterfaceCaption("toggleAutoManual", "tooltip_button_ToggleAutoManual","tooltip_button_"..this.AutoManual,"X")
	this.Tooltip = { "tooltip_WaterTank",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M" }
	if not this.FiremanBack and this.CheckForReturningFiremen == true then
		if this.AutoManual == "AUTO" then 
			this.Tooltip = { "tooltip_Watertank_FiremenAutoWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",fireNumber,"D",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
		else
			this.Tooltip = { "tooltip_Watertank_FiremenManualWaitForReturn",this.HomeUID,"H",this.FireAlarm,"F",this.AutoManual,"N",TeamChar[this.Team],"T",this.TeamMembers,"M",this.ReturningFiremanNr,"R",this.DeadFiremanNr,"K" }
		end
	end
end
		




function JobComplete_InspectWaterTankT1M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT2M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT3M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT4M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT5M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT6M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT7M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT8M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT9M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT10M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT11M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT12M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT13M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT14M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT15M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT16M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT17M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT18M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT19M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT20M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT21M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT22M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT23M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT24M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT25M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_InspectWaterTankT26M4()
	Member4.NavigateTo(this.Pos.x+1.15,this.Pos.y+1.15)
end

function JobComplete_GrabHoseT1M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT1M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT1M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT1M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT2M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT2M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT2M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT2M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT3M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT3M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT3M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT3M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT4M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT4M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT4M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT4M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT5M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT5M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT5M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT5M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT6M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT6M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT6M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT6M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT7M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT7M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT7M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT7M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT8M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT8M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT8M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT8M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT9M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT9M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT9M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT9M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT10M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT10M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT10M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT10M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT11M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT11M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT11M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT11M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT12M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT12M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT12M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT12M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT13M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT13M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT13M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT13M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT14M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT14M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT14M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT14M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT15M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT15M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT15M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT15M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT16M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT16M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT16M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT16M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT17M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT17M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT17M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT17M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT18M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT18M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT18M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT18M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT19M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT19M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT19M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT19M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT20M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT20M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT20M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT20M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT21M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT21M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT21M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT21M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT22M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT22M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT22M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT22M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT23M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT23M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT23M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT23M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT24M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT24M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT24M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT24M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT25M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT25M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT25M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT25M4()
	SwapGuys(Fireman4,4)
end

function JobComplete_GrabHoseT26M1()
	SwapGuys(Fireman1,1)
end

function JobComplete_GrabHoseT26M2()
	SwapGuys(Fireman2,2)
end

function JobComplete_GrabHoseT26M3()
	SwapGuys(Fireman3,3)
end

function JobComplete_GrabHoseT26M4()
	SwapGuys(Fireman4,4)
end




--Return Object if in range.
function GetObject(theType,theID,theDistance)
	local nearbyObjects = Object.GetNearbyObjects(this,theType,theDistance or 1)
	for thatObject, d in pairs(nearbyObjects) do
		 if thatObject.Id.u == theID then
		 	return thatObject
		 end
	end
	nearbyObjects = nil
end

--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        print(tostring("Trying to load "..Type.." with ID: "..ID))
        local TempID = Get(this,ID)
		if TempID ~= nil and TempID ~= "None" then
			Object = GetObject(Type,TempID,dist)
			if Object == nil then
				Set(this,ID,"None")
				Object = ""
				print(Type.." not found.")
			else
				print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID)
			end
		else
			print(ID.." not found.")
		end
    end
    return Object
end
