local timeTot = 0

local Fireman1 = ""
local Fireman2 = ""
local Fireman3 = ""
local Fireman4 = ""

local fireNumber = 0
local FireScanRange = 75
local retryCounter = 0

local TeamChar = { [1] = "A", [2] = "B", [3] = "C", [4] = "D", [5] = "E", [6] = "F", [7] = "G", [8] = "H", [9] = "I", [10] = "J", [11] = "K", [12] = "L", [13] = "M", [14] = "N", [15] = "O", [16] = "P", [17] = "Q", [18] = "R", [19] = "S", [20] = "T", [21] = "U", [22] = "V", [23] = "W", [24] = "X", [25] = "Y", [26] = "Z" }

function Create()
	Set("TotalFound",0)
    Set("Fireman1ID","None")
    Set("Fireman2ID","None")
    Set("Fireman3ID","None")
    Set("Fireman4ID","None")
	Set("WaterTankID","None")
end

function Update(timePassed)
	if timePerUpdate == nil then
	-------------------------------------------------------------------------------------------
	-- Load References
	-------------------------------------------------------------------------------------------
		-- Fireman1 = Load(Fireman1,"Fireman","Fireman1ID",10000)
		-- Fireman2 = Load(Fireman2,"Fireman","Fireman2ID",10000)
		-- Fireman3 = Load(Fireman3,"Fireman","Fireman3ID",10000)
		-- Fireman4 = Load(Fireman4,"Fireman","Fireman4ID",10000)

		timePerUpdate = 0.25
	end
	-------------------------------------------------------------------------------------------
	
	timeTot = timeTot + timePassed
	if timeTot >= timePerUpdate then
		timeTot = 0
		
		if not Get("FiremanFound") then		-- first find the callout firemen
			local nearbyFireman = this.GetNearbyObjects("Fireman",10000)
			if next(nearbyFireman) then
				for thatFireman , d in pairs(nearbyFireman) do
					for j=0,3 do
						if Get("Slot"..j..".i") == thatFireman.Id.i then
							Set("Fireman"..(j+1).."ID",thatFireman.Id.i)
						end
					end
				end
				Fireman1 = ""
				Fireman2 = ""
				Fireman3 = ""
				Fireman4 = ""
				Fireman1 = Load(Fireman1,"Fireman","Fireman1ID",10000)
				Fireman2 = Load(Fireman2,"Fireman","Fireman2ID",10000)
				Fireman3 = Load(Fireman3,"Fireman","Fireman3ID",10000)
				Fireman4 = Load(Fireman4,"Fireman","Fireman4ID",10000)
				if Get("Fireman1ID") ~= "None" and Get("Fireman2ID") ~= "None" and Get("Fireman3ID") ~= "None" and Get("Fireman4ID") ~= "None" then
					Fireman1.Hidden = true
					Fireman2.Hidden = true
					Fireman3.Hidden = true
					Fireman4.Hidden = true
					Set("FiremanFound",true)
					timePerUpdate = 0.25
				end
			end
			nearbyFireman = nil
			if not Get("FiremanFound") then
				retryCounter = retryCounter+1
				if retryCounter > 10 then
					this.Delete()
					return
				end
			end
		elseif not Get("WaterTankFound") then	-- find Prison firemen and a watertank near fires
			local tankFound = false
			nearbyTank = this.GetNearbyObjects("WaterTank2",10000)
			if next(nearbyTank) then
				for thatManualTank, d in pairs(nearbyTank) do
					if GetFrom(thatManualTank,"AutoManual") == "MANUAL" and GetFrom(thatManualTank,"WaterTankSearcherID") == "None" and GetFrom(thatManualTank,"TeamMembers") > 0 then
						myTank = thatManualTank
						tankFound = true
						break
					end
				end
				if tankFound == false then
					local CurrentDist = 10000
					for thatAutoTank, d in pairs(nearbyTank) do
						fireNumber = 0
						if GetFrom(thatAutoTank,"WaterTankSearcherID") == "None" and GetFrom(thatAutoTank,"TeamMembers") > 0 then
							local nearbyFires = FindFrom(thatAutoTank,"Fire",FireScanRange)
							for thatFire, dist in pairs(nearbyFires) do
								fireNumber = fireNumber+1
								if dist <= CurrentDist then
									CurrentDist = dist
									myTank = thatAutoTank
									tankFound = true
								end
							end
						end
					end
				end
				if tankFound == false then		-- no unused WaterTanks found within range of any fire, so get rid of the callout
					Fireman1.Delete()
					Fireman2.Delete()
					Fireman3.Delete()
					Fireman4.Delete()
					this.Delete()
					return
				else
					Set("WaterTankID",myTank.Id.i)
				end
				if myTank.TeamMembers == 0 then		-- no Prison Firemen found, so get rid of the callout
					Fireman1.Delete()
					Fireman2.Delete()
					Fireman3.Delete()
					Fireman4.Delete()
					this.Delete()
					return
				end
				
				SetOn(myTank,"WaterTankSearcherID",this.Id.u)
				myTank.SubType = 1
				this.Pos.x = myTank.Pos.x+1.75		-- teleport to a spot where the hose will be behind the WaterTank
				this.Pos.y = myTank.Pos.y+2.5		-- hose appears at some hard coded spot on firetruck (left side, back end of truck)? so this is to compensate for that location

				Set("WaterTankFound",true)
				
			else										-- no WaterTank nor fires found, so get rid of the callout
				Fireman1.Delete()
				Fireman2.Delete()
				Fireman3.Delete()
				Fireman4.Delete()
				this.Delete()
				return
			end
		elseif not Get("Walked") then
			Walk(Fireman1,this.Slot0)
			Walk(Fireman2,this.Slot1)
			Walk(Fireman3,this.Slot2)
			Walk(Fireman4,this.Slot3)
			Set("Walked",true)
		else
			if myTank.Member1ID == "None" then SetOn(myTank,"Fireman1Available",false); Fireman1.Delete() else SetOn(myTank,"Fireman1Available",true); Fireman1.Damage = 0; Swap(Fireman1,1,myTank.Slot4); newHose1 = Object.Spawn("HoseIcon",myTank.Pos.x+0.05,myTank.Pos.y+0.25);	SetOn(newHose1,"HoseNr",1) end
			if myTank.Member2ID == "None" then SetOn(myTank,"Fireman2Available",false); Fireman2.Delete() else SetOn(myTank,"Fireman2Available",true); Fireman2.Damage = 0; Swap(Fireman2,2,myTank.Slot5); newHose2 = Object.Spawn("HoseIcon",myTank.Pos.x+0.15,myTank.Pos.y+0.25);	SetOn(newHose2,"HoseNr",2) end
			if myTank.Member3ID == "None" then SetOn(myTank,"Fireman3Available",false); Fireman3.Delete() else SetOn(myTank,"Fireman3Available",true); Fireman3.Damage = 0; Swap(Fireman3,3,myTank.Slot6); newHose3 = Object.Spawn("HoseIcon",myTank.Pos.x+0.25,myTank.Pos.y+0.25);	SetOn(newHose3,"HoseNr",3) end
			if myTank.Member4ID == "None" then SetOn(myTank,"Fireman4Available",false); Fireman4.Delete() else SetOn(myTank,"Fireman4Available",true); Fireman4.Damage = 0; Swap(Fireman4,4,myTank.Slot7); newHose4 = Object.Spawn("HoseIcon",myTank.Pos.x+0.35,myTank.Pos.y+0.25);	SetOn(newHose4,"HoseNr",4) end

			SetOn(myTank,"WaterTankBusy",true)		-- ready to be processed by the WaterTank
			if GetFrom(myTank,"AutoManual") == "AUTO" then
				myTank.Tooltip = {"tooltip_Watertank_FiremenAvailableAuto",myTank.HomeUID,"H",myTank.FireAlarm,"F",myTank.AutoManual,"N",TeamChar[myTank.Team],"T",fireNumber,"D",myTank.TeamMembers,"M"}
			else
				myTank.Tooltip = {"tooltip_Watertank_FiremenAvailableManual",myTank.HomeUID,"H",myTank.FireAlarm,"F",myTank.AutoManual,"N",TeamChar[myTank.Team],"T",myTank.TeamMembers,"M"}
			end
			Set("WaterTankFound",true)
			timePerUpdate = 60 / 0.75
			this.Delete()
		end
	end
end

function Walk(theFireman,fromSlot)
	fromSlot.i = -1
	fromSlot.u = -1
	theFireman.CarrierId.i = -1
	theFireman.CarrierId.u = -1
	theFireman.Loaded = false
	theFireman.Pos.x = myTank.Pos.x
	theFireman.Pos.y = myTank.Pos.y+0.25
	-- start PA 2018 code
	theFireman.NavigateTo(myTank.Pos.x,myTank.Pos.y)
	-- finish PA 2018 code
	
	-- start PA Rock code
	-- theFireman.PlayerOrderPos.x = myTank.Pos.x
	-- theFireman.PlayerOrderPos.y = myTank.Pos.y
	-- finish PA Rock code
end

        -- AssignedVehicle.i = myTank.Id.i -- new values discovered in savedgame after The Rock game update
        -- AssignedVehicle.u = myTank.Id.u
function Swap(theFireman,theID,toSlot)
	SetOn(myTank,"Fireman"..theID.."ID",theFireman.Id.u)
	toSlot.i = theFireman.Id.i		-- load them onto Slot 4-7 at the WaterTank: when they return they want to get in Slot0-3
	toSlot.u = theFireman.Id.u		-- so this way fresh firemen should never collide with returning firemen in case that gets implemented
	theFireman.CarrierId.i = myTank.Id.i
	theFireman.CarrierId.u = myTank.Id.u
	theFireman.Loaded = true
	theFireman.Tooltip = "tooltip_QueuedFireman"
	SetOn(theFireman,"IsPrisonFireman",true)
	SetOn(theFireman,"KilledInAction",false)
	theFireman.SubType = 4			-- subtype 4 is an empty sprite, so the guy is hidden for now
	theFireman.Equipment = 0		-- hide his hose as well, otherwise we see two hands holding a hose and no fireman
	
	-- start PA Rock code
	-- theFireman.FireEngine.i = myTank.Id.i
	-- theFireman.FireEngine.u = myTank.Id.u
	-- finish PA Rock code
end




function FindFrom(theSource,theObject,theRange)		 -- returns target objects in a square around the object
	local Xmin=math.ceil(theSource.Pos.x-theRange/2)
	local Xmax=math.ceil(theSource.Pos.x+theRange/2)
	local Ymin=math.ceil(theSource.Pos.y-theRange/2)
	local Ymax=math.ceil(theSource.Pos.y+theRange/2)
	local ListOfObjects = Object.GetNearbyObjects(theSource,theObject,theRange*1.2)
	for thatObject, distance in pairs(ListOfObjects) do
		if (thatObject.Pos.x>=Xmin and thatObject.Pos.x<=Xmax) and (thatObject.Pos.y>=Ymin and thatObject.Pos.y<=Ymax) then
		-- it's ok, put other stuff here if you need
		else
			ListOfObjects[thatObject]=nil -- remove the out of bounds object from the list
		end
	end
	return ListOfObjects
end	











-------------------------------------------------------------------------------------------
-- Helper Functions
------------------------------------------------------------------------------------------- 
function Set(name, value)
    Object.SetProperty(name, value);
end
function Get(name)
    return Object.GetProperty(name);
end
function GetN(name)
    return tonumber(Object.GetProperty(name));
end
function GetFrom(ident, name)
    return Object.GetProperty(ident, name);
end
function SetOn(ident, name, value)
    return Object.SetProperty(ident, name, value);
end
function Print(text)
    Game.DebugOut("Cat", text);
end
function PrintProperty(name)
    local property = Get(name);
    if property == nil then
        property = "nil";
    end    
    
    Print(name .. ": " .. tostring(property));
end
function PropStr(prop)
    return " " .. prop .. ": " .. tostring(Get(prop));
end--]]


-- get the length of a table
function len(tab)
	local count = 0
	for _ in pairs(tab) do
		count = count + 1
	end
	return count
end
--Return Object if in range.
function GetObject(type,id,dist)
	objs = Object.GetNearbyObjects(type,dist or 1)
	for o,d in pairs(objs) do
		 if o.Id.i == id then
		 	return o
		 end
	end
end
--Find Object after Load.
function Load(Object, Type, ID, dist)
    if Object == "" then
        Print(tostring("Trying to load "..Type.." with ID: "..ID));
        TempID = Get(tostring(ID));
        Object = GetObject(Type,TempID,dist);
        Print("Found: "..Type.." Table: "..tostring(Object).." ID: "..TempID);
    end
	if Object == nil then Set(ID,"None") Object = "" end
    return Object
end