
local timeTot = 0
local stage = 1		-- 1 = the days before Christmas, 7 = during Christmas with unpacking enabled
local chanters = 0
local buttons
local Set = Object.SetProperty
local Get = Object.GetProperty

local presents = {"SylvesterLotterySuperJackpot",
	-- default IV objects
"Bed","BunkBed","SuperiorBed","Crib","PlayMat","Toilet","Table","Chair","Bench","ElectricChair","JailDoor","JailDoorLarge","RoadGate","RoadBarrier","Door","StaffDoor","SolitaryDoor","RemoteDoor","JailBars","Window","BarbedWire","WindowLarge","Tree","Cooker","Fridge","Bin","Sink","ServingTable","ShowerHead","Bookshelf","OfficeDesk","SchoolDesk","FilingCabinet","MedicalBed","MorgueSlab","PowerStation","Capacitor","PowerSwitch","WaterPumpStation","WaterBoiler","PipeValve","Sprinkler","Drain","MetalDetector","WeightsBench","PhoneBooth","Tv","LargeTv","PoolTable","Cctv","CctvMonitor","DoorControlSystem","PhoneMonitor","Servo","DoorTimer","LogicCircuit","LogicBridge","PressurePad","StatusLight","LaundryMachine","WorkshopSaw","WorkshopPress","CarpenterTable","IroningBoard","LaundryBasket","VisitorTable","VisitorTableSecure","DogCrate","GuardLocker","WeaponRack","SofaChairSingle","SofaChairDouble","DrinkMachine","ArcadeCabinet","Radio","Altar","Pews","PrayerMat","LibraryBookshelf","SortingTable","ShopFront","ShopShelf","GuardTower","Radiator","SylvesterLotterySuperJackpot",
	-- default Paradox objects
"SpookyTree","SnowyConiferTree","CactusTree","SakuraTree","PalmTree","Plant","PlantCactus","Bush","BathroomSink","BathroomHandDryer","ChestOfDrawers","ShortBookcase","WoodenStool","WoodenTable","OutdoorTable","DoorMat","TyreStack","FloodLight","StreetLamp","Lamp","VisitorDoor","IroningBoardShort","Bleachers","ParkBench","SmallBench","OakBench","OakTable","SmallTable","ShowerPillar","FenceGateStandard","FenceGateStaff","FenceGateVisitor","FenceGateGuard","JailDoorRed","JailDoorGrey","JailDoorOrange","JailDoorYellow","JailDoorLargeRed","JailDoorLargeGrey","JailDoorLargeOrange","JailDoorLargeYellow","CoatStand","DogBowl","WallLight","MooseHead","ArmourySign","LeftArrowSign","RightArrowSign","CanteenSign","InfirmarySign","ShowerSign","ToiletSign","OfficeChair","GuardPavilion","GuardPavilionCorner","SecureDoor","SecretDoor","Footbridge","FootbridgeSteel","FootbridgeB","FootbridgeSteelB","WindowClassy","WindowClassyLarge","RorschachTest","AnatomyModel","Flipboard","MedicineCabinetPsych","LeatherChair","LeatherSofa","Gravestone","BambooDoor","Painting1","Painting2","ChessTable","GlassWindow","GlassWindowLarge","GymMat","TableTennis","TableFootball","TyreApparatus","SinkMirror","OvalStaffTable","Canvas","PetBird","SoftPillow","BoxingRing","DumbbellRack","Fan","PunchBag","WardenStatue","WaterCooler","SnackMachine","Mattress","WoodenBarrel","MetalBarrel","MooringBollard","LightGreen","LightRed","WalkwayStairs","Buoy","LifeRing","CoffeeMachine","ComputerStation","PASystem","Treadmill","TrainingDummy","WoodenDockFloor","StoneWaterSpout","WindSock","ComfyBed","IndoorTreePlanter","OldBed","CameraPillar","Blackboard","JailDoorWhite","JailDoorLargeWhite","DeckChair","SteppingStoneLillyPad","SteppingStoneIceBlock","SteppingStone","SteppingStonePallet","Helipad","FerryDock","BoatDock","ScannerMonitor","ScannerMachine","CheckPoint","Fountain","SylvesterLotterySuperJackpot",
	-- modded objects
"VisitorTableWhite","ArcadeCabinetMod","InvisibleLightSpawner","DefaultLightSpawner","TLLightSpawner","LightBulbSpawner","OutdoorLightSpawner","GardenLightSpawner","DoubleFloodLightSpawner","ServerSpawner","ServerPartsRack","ClassroomPCSpawner","FreeTimeEcoComputerSpawner","FreeTimeComputerStandardSpawner","FreeTimeThinClientSpawner","FreeTimeLaptopStandardSpawner","FreeTimeComputerDeluxeSpawner","FreeTimeLearningComputerSpawner","SylvesterLotterySuperJackpot","BoringFilingCabinet","WorkThinClientSpawner","NetworkPrinterTinySpawner","NetworkPrinterSmallSpawner","NetworkPrinterLargeSpawner","PrinterPaperSmallRack","PrinterTonerSmallRack","PrinterDrumkitSmallRack","PrinterPaperLargeRack","PrinterTonerLargeRack","PrinterDrumkitLargeRack","AdminDeskSpawner","HQFilingCabinet","CentredOfficeChair","OakDesk","OakBookShelf","BookShelfLarge","HiddenDoor","ChesterfieldChair","ChesterfieldSofa","CigaretteMachine","ElectricRadiator","MiniBench","BenchSmall","WoodenWindow","WoodenWindowLarge","GlassWindow","SuperiorTable","SuperiorBench","SmallWoodenSink","SmallSink","YogaMat","GraveCoffinSpawner","GraveStoneSpawner","CoffinTable","SmallTableMorgue","SmallTableFP","ParlourChair","ParlourAltar","ParlourAltarStaff","Crematorium","SmallPews","Candelabra","ChurchStatue","ChurchWindow","UrinalPreview","NiceToiletAPreview","NiceToiletBPreview","TurkishDrainPreview","WoodenShitHolePreview","BathroomStallPreview","OuthousePreview","ToiletDry","Urinal","NiceToilet","NiceToilet2","TurkishDrain","WoodenShitHole","BathroomStall","Outhouse","WallSinkPreview","WallSink","MedicalBedLarge","FirstAidBox","Eeg","IntravenousPole","FireExtinguisher","WaterTank2","FiremanLocker2","FiremanShowerHead2","PrisonFireAlarm2","StaffDoorWood","StaffDoorMin","StaffDoorMed","StaffDoorMax","StaffDoorSupMax","StaffDoorDeathRow","StaffDoorProt","StaffDoorInsane","StaffDoorShared","GlassDoor","ModernDoor","HeavyDoor","JailDoorXL","HeavyDoorLarge","BlastDoor","SolitaryDoorMin","SolitaryDoorMed","SolitaryDoorMax","SolitaryDoorSuper","SolitaryDoorDeathRow","SolitaryDoorProt","SolitaryDoorShared","VendingMachineFruit","VendingMachinePrisonerUniform","VendingMachineSandwich","VendingMachineBurger","VendingMachineWater","VendingMachineSnack","VendingMachineCoffee","VendingMachineSoup","VendingMachineShop","VendingMachineNews","VendingMachineMedicine","VendingMachineOrangeJuice","VendingMachineWaterCooler","VendingWaterFountain","VendingStorageRack","VendingOrangeJuicer","VendingTreeOrange","VendingTreeApple","VendingTreeCherry","VendingAirConditioner","VendingMachineLottery","VendingLotterySafe","VendingMoneySafe","ForestryTreeSaplingPlanted","WoodSaw","MetalStorageRack","LogStorageRack","WoodStorageRack","BarberChair","BarberChairScripted","BarberMirror","BlondBarberPress","BrownBarberPress","RedBarberPress","CircuitIsolator2","PrisonerSorter","BasketballContainer3","BasketballCourtFull","BasketballCourtHalf","BasketballBench","BasketballLocker","PrisonBoxingRing","SpeedBag","ControlBooth","ControlBoothMedium","ControlBoothLarge","SmartPhoneDetector","RiggedPhoneSpawner","PhonePress","PhoneTable","SmallTablePhoneWorkshop","AluminiumStorageRack","TrashBin","RecycleBin","TrashCompactor","RotatableRecycleDeskVisible","SmallGardenTable","SmallGardenBench","FenceBush","FoliagePlantA","FoliagePlantB","FoliagePlantC","FoliagePlantD","FoliagePlantE","FoliagePlantF","FoliagePlantG","FoliagePlantH","FlowersA","FlowersB","FlowersC","FlowersD","FlowersE","SylvesterLotterySuperJackpot","FlowersShared","FlowersMinsec","FlowersMedsec","FlowersMaxsec","FlowersPrsec","Bush1","Bush2","Buxus","SmallBuxus","FlowerPot1","FlowerPot2","FlowerPot3","FlowerPot4","FlowerPot5","FlowerPot6","Tulips1","Tulips2","Tulips3","Tulips4","BeeBox","SmallGardenTableFerti","GardenPotRemoteTomato","GardenPotRemoteCucumber","GardenPotRemoteRose","GardenPotRemoteLily","GardenPotRemoteIngredients","GardenPotRemotePotatoes","GardenPlantControlSpawner","ShedSpawner","SmallTableManufactury","SewingStation","TextileMill","SmallGardenTablePlantation","SylvesterLotterySuperJackpot","CottonPlantSpawner","CottonPlantControlSpawner","SmallGardenTableCotton","SaunaBench","SaunaBenchLarge","TeslaMatic3","MoneyTable","MoneySafe","GoldBars","MoneyStatue","PrisonerStatue","ZoneDesignator","ServoProxy","StatusLightProxy","BoomBox","PingPongTable","CoffeeTable","DiningChair","DiningTable","SofaBlueLeft","SofaBlueRight","Sofa","SofaRight","SofaChair","SofaBeige","LivingRoomTV","HouseDoor","BathTub","Cupboard","VanityTable","Mirror","BedsideCab1","BedsideCab2","DoubleBed","StreetLightLeft","StreetLightRight","TrafficLightLeft","TrafficLightRight","BusStop","RoadMarker","StreetLightLeft","StreetLightRight","SylvesterLotterySuperJackpot","TrafficLightRight","BusStop","PrisonSign","MailBox","ExitSign","Hydrant","stopsign","parkingsign","ElegantCar","CopCar","RedCar","BlackLimo","BlueLimo","RedLimo","CargoTruck","PrisonerTruck","MedicalTruck","FireTruck","RiotTruck","ArmyTruck","EngineTruck","CarTruck","RailwayManager","TrainSpawner","RailwayTrackSign","RailwayCrossingSign","RailwaySign","RailwaySignRed","RailwaySignGreen","BumperBlock","Train","Wagon1","Wagon2","Wagon3","Wagon4","ShunterTrain","Locomotive","EvacBench","EvacChair","EntryTag","ExitTag","1tileArrow","2tileArrow","3tileArrow","4tileArrow","5tileArrow","MinTag","MedTag","MaxTag","SuperTag","ProtectTag","DeathRowTag","InsaneTag","CellBlockTag","HoldingTag","DormitoryTag","FamilyCellTag","NurseryTag","SolitaryTag","StaffTag","AccountantTag","ChiefTag","ForemanTag","LawyerTag","OfficeTag","PsychologistTag","WardenTag","ArmouryTag","BarberyTag","BasketballCourtTag","BoxingTag","CanteenTag","CarpentryWorkshopTag","ChapelTag","ClassroomTag","CleaningTag","VendingStorageTag","CottonPlantationTag","CommonTag","DeliveriesTag","EvacuationTag","ExecutionTag","ExportsTag","GarageTag","GarbageTag","GardenTag","GreenhouseTag","ForestryTag","InfirmaryTag","KennelTag","KitchenTag","LandingZoneTag","LaundryTag","LibraryTag","MailRoomTag","ManufacturyTag","MorgueTag","OfficeTag","ParkingZoneTag","ParoleTag","PhoneWorkshopTag","ReceptionTag","RecyclingTag","SecurityTag","SaunaTag","ShopTag","ShowerTag","StaffTag","StaffRoomTag","StaffToiletsTag","StorageTag","TherapyTag","ToiletsTag","UtilityRoomTag","VisitationTag","WaterPumpTag","WaterPumpTag","YardTag","YogaroomTag","WorkshopTag","LockdownTag","PermanentTag","PowerTag","BackupTag","NoEntryTag","ExplosiveCharge666","Detonator666","MaterialDuper","VisitorDoorWood","VisitorDoorMin","VisitorDoorMed","VisitorDoorMax","VisitorDoorProt","ToughVisitorDoor","VisitorDoorDeathRow","VisitorDoorShared","SylvesterLotterySuperJackpot","SylvesterLotteryMegaJackpot" }


local received = {}

function Create()
	this.Presents = 0
end 

function Update(timePassed)
	timeTot = timeTot + timePassed
	if timeTot > 10 then
		timeTot = 0
		if chanters >= 2 then
			chanters = 0
		else
			for i = 1,7 do
				if this["Slot"..i].i ~= -1 then
					chanters = chanters + 1
				end
			end
			if chanters >= 2 then
				Caroling()
			end
		end
		if stage == 7 then
			if this.SubType > 0 then
				Unpack()
			end
		else
			Pack()
		end
	end
end

function Pack()
	if not this.Job and math.random() > 0.987 then
		this.Job = true
		if stage == 1 and this.Presents < 5 and math.random() > 0.6 then
			this.CreateJob("PackPresent")
		else
			this.CreateJob("AdmireTree")
		end
	end
end

function JobComplete_PackPresent()
    PlacePresent()
	this.Job = nil
end

function PlacePresent()
	if stage == 1 and this.Presents < 5 then
		this.Presents = this.Presents + 1
		if this.SubType <= 0 then
			this.SubType = 1
			this.Tooltip = "1 Present under the Tree"
		else
			this.Tooltip = this.Presents.." Presents under the Tree"
		end
		
	end
end

function TreeBtn1Clicked()
	if this.EnabledUnpack then
		this.EnabledUnpack = nil
		if this.Presents > 0 then
			this.SetInterfaceCaption("TreeBtn1", "christmas_interface_unpack")
		else
			this.RemoveInterfaceComponent("TreeBtn1", "Button", "christmas_interface_unpack")
		end
	else
		this.EnabledUnpack = true
		this.SetInterfaceCaption("TreeBtn1", "christmas_interface_stop")
	end
end

function Unpack()
	if stage == 7 and this.Presents > 0 then
		if this.EnabledUnpack then
			if not this.Job and math.random() > 0.6 then
				this.Job = true
				this.CreateJob("UnpackPresent")
			end
		elseif not buttons then
			this.AddInterfaceComponent("TreeBtn1", "Button", "christmas_interface_unpack")
			buttons = true
		end
	end
end

function JobComplete_UnpackPresent()
    SpawnGift()
	this.Job = nil
	if this.Presents <= 0 then
		Set(this,"Presents",0)
		this.RemoveInterfaceComponent("TreeBtn1", "Button", "christmas_interface_unpack")
	end
end

function SpawnGift()
	local gift = presents[math.random(#presents)]

	local present = Object.Spawn("Box", this.Pos.x, this.Pos.y+1.5)
	local BoxNr = 0
	for i = 1,5000 do
		Set(present,"Contents",i)
		if present.Contents == gift then
			BoxNr = i
		end
		if BoxNr > 0 then
			local velX = -1.0 + math.random() + math.random()
			local velY = -1.0 + math.random() + math.random()
			Object.ApplyVelocity(present, velX, velY)
			break
		end
	end
	if BoxNr == 0 then
		present.Delete()
	else
		if gift == "SylvesterLotterySuperJackpot" then
			jackpot = Object.Spawn("SylvesterLotterySuperJackpot", present.Pos.x, present.Pos.y)
			present.Delete()
		elseif gift == "SylvesterLotteryMegaJackpot" then
			jackpot = Object.Spawn("SylvesterLotteryMegaJackpot", present.Pos.x, present.Pos.y)
			present.Delete()
		end
		
		if not received[gift] then
			received[gift] = 1
		else
			received[gift] = received[gift] + 1
		end
		this.Presents = this.Presents - 1
	end
	
	this.Sound("_Tools","HitBy_DogBite")
	if this.Presents > 0 then
		if this.Presents == 1 then
			this.Tooltip = "1 Present under the Tree"
		else
			this.Tooltip = this.Presents.." Presents under the Tree"
		end
	else
		if this.SubType > 0 then
			this.SubType = 0
		end
		ReportPresents()
	end
end

function ReportPresents()
	local giftstr = "Unpacked"
	for id, nr in pairs(received) do
		giftstr = (giftstr.." "..nr.." x "..id)
	end
	this.Tooltip = giftstr
end

function Caroling()
	this.Sound("Prisoner","Heckle")
end

function JobComplete_AdmireTree()
	this.Job = nil
end
