
local Get = Object.GetProperty
local Set = Object.SetProperty
local Find = Object.GetNearbyObjects

local timeTot = 0

local TeamChar = { [0] = "None", [1] = "A", [2] = "B", [3] = "C", [4] = "D", [5] = "E", [6] = "F", [7] = "G", [8] = "H", [9] = "I", [10] = "J", [11] = "K", [12] = "L", [13] = "M", [14] = "N", [15] = "O", [16] = "P", [17] = "Q", [18] = "R", [19] = "S", [20] = "T", [21] = "U", [22] = "V", [23] = "W", [24] = "X", [25] = "Y", [26] = "Z" }

function Create()
	print("Create")
	Set(this,"HomeUID","None")
	Set(this,"WaterTankID","None")
	Set(this,"Team",0)
	Set(this,"Member","None")
	this.Tooltip = "tooltip_LockerNotInUse"
	-- FindMyChief()
end

-- function FindMyChief()
	-- print("FindMyChief")
	-- local found = false
	-- local nearbyChiefs = Find(this,"PrisonFireman2Chief",10000)
	-- if next(nearbyChiefs) then
		-- for thatChief, distance in pairs(nearbyChiefs) do
			-- Set(thatChief,"FindNewLockers",true)
			-- found = true
			-- break
		-- end
	-- end
	-- nearbyChiefs = nil
	-- if found == true then
		-- print("MyChief found")
	-- else
		-- print("No PrisonFireman2Chief")
	-- end
-- end

function FindMyWaterTank()
	print("FindMyWaterTank")
	local found = false
	local nearbyTanks = Find(this,"WaterTank2",10000)
	if next(nearbyTanks) then
		for thatTank, distance in pairs(nearbyTanks) do
			if thatTank.Id.u == Get(this,"WaterTankID") then
				MyWaterTank = thatTank
				found = true
			end
		end
	end
	nearbyTanks = nil
	if found == true then
		print("MyWaterTank found")
	else
		print("No WaterTanks")
	end
end

function CheckForNearestShower()
	print("CheckForNearestShower T"..TeamChar[Get(this,"Team")].."M"..Get(this,"Member"))
	local found = false
	local CurrentDist = 100
	local nearbyShowers = Find(this,"FiremanShowerHead2",100)
	if next(nearbyShowers) then
		for thatShower, distance in pairs(nearbyShowers) do
			if Get(thatShower,"InUse") == nil then
				if distance < CurrentDist then
					CurrentDist = distance
					MyShower = thatShower
					found = true
				end
			end
		end
	end
	nearbyShowers = nil
	if found == true then
		print("MyShower found")
		Set(MyShower,"Team",this.Team)
		Set(MyShower,"Member",this.Member)
		Set(MyShower,"InUse",true)
		Set(MyShower,"LockerID",this.Id.u)
		Object.CreateJob(MyShower,"FiremanTurnOnShowerT"..this.Team.."M"..this.Member)
	else
		print("No free Showers")
	end
end

function ChangeClothes()
	print("ChangeClothes T"..TeamChar[Get(this,"Team")].."M"..Get(this,"Member"))
	if this.Team == 0 then
		Object.CancelJob(this,"ChangeFiremanClothesNoneNone")
	else
		Object.CancelJob(this,"ChangeFiremanClothesT"..this.Team.."M"..this.Member)
	end
	this.CreateClothesJob = nil
	
	local nearbyFireman = Find(this,"PrisonFiremanT"..this.Team.."M"..this.Member,2)
	if next(nearbyFireman) then
		for thatFireman, dist in pairs(nearbyFireman) do
			if thatFireman.SubType == 1 then		-- has dirty clothes
				print("Found my dirty PrisonFiremanT"..TeamChar[this.Team].."M"..this.Member..", taking clothes off")
				CheckForNearestShower()
				if Exists(MyShower) then
				
					if thatFireman.Hidden == true then
						Set(thatFireman,"Hidden",false)	-- a hidden firemen walks back from the tank after a fireman got killed in action
						if not Exists(MyWaterTank) then FindMyWaterTank() end
						Set(MyWaterTank,"Member"..this.Member.."ID",thatFireman.Id.u) -- tells the watertank that a "new" prison fireman is ready for action
						Set(MyWaterTank,"TeamMembers",MyWaterTank.TeamMembers+1)
					end

					Set(this,"SubType",2)		-- open locker sprite
					Set(thatFireman,"SubType",2)	-- make him naked
				else
					Set(thatFireman,"SubType",0)	-- abort and reset sprite to normal
					Set(thatFireman,"ShowerSequenceStarted",false)
				end
				MyShower = nil
			elseif thatFireman.SubType == 3 then		-- naked, type 3 triggered him to come back here
				print("Found my naked PrisonFiremanT"..TeamChar[this.Team].."M"..this.Member..", putting clothes on")
				Set(this,"SubType",1)
				Set(thatFireman,"SubType",0)
				Set(thatFireman,"ShowerSequenceStarted",false)
				if this.Member == 4 then
					if not Exists(MyWaterTank) then FindMyWaterTank() end
					if Get(MyWaterTank,"WaterTankBusy") == false then
						Object.CreateJob(MyWaterTank,"InspectWaterTankT"..this.Team.."M4")
					end
				end
			end
			break
		end
	end
	nearbyFireman = nil
end

function Exists(theObject)
	if theObject ~= nil and theObject.SubType ~= nil then
		return true
	else
		return false
	end
end

function JobComplete_ChangeFiremanClothesT1M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT1M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT1M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT1M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT2M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT2M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT2M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT2M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT3M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT3M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT3M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT3M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT4M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT4M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT4M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT4M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT5M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT5M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT5M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT5M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT6M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT6M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT6M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT6M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT7M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT7M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT7M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT7M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT8M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT8M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT8M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT8M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT9M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT9M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT9M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT9M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT10M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT10M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT10M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT10M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT11M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT11M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT11M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT11M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT12M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT12M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT12M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT12M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT13M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT13M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT13M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT13M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT14M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT14M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT14M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT14M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT15M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT15M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT15M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT15M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT16M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT16M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT16M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT16M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT17M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT17M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT17M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT17M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT18M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT18M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT18M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT18M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT19M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT19M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT19M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT19M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT20M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT20M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT20M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT20M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT21M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT21M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT21M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT21M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT22M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT22M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT22M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT22M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT23M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT23M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT23M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT23M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT24M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT24M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT24M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT24M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT25M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT25M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT25M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT25M4() ChangeClothes() end

function JobComplete_ChangeFiremanClothesT26M1() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT26M2() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT26M3() ChangeClothes() end
function JobComplete_ChangeFiremanClothesT26M4() ChangeClothes() end
