
local Get = Object.GetProperty
local Set = Object.SetProperty
local Christmas = false

function Create()
end

function Update()
	CreateFoundation()
	this.Delete()
end

function CreateFoundation()
	local CompactFloor = {
			{ 1, 1, 1, 1 },
			{ 1, 2, 2, 1 },
			{ 3, 3, 3, 3 }
			}

	local Tiles = {
			[0] = "Excluded", -- 0 = excluded from changing
			[1] = "BrickWall",
			[2] = "MosaicFloor",
			[3] = "ConcreteTiles",
			[4] = "Dirt"
			}

	local MyFloor = {}
	MyFloor = CompactFloor
	local x = math.floor(this.Pos.x)-3
	local y = math.floor(this.Pos.y)-2
	
	for X = 1,4 do
		for Y = 1,3 do
			local cell = World.GetCell(x+X,y+Y)
			if Tiles[MyFloor[Y][X]] ~= "Excluded" then
				cell.Mat = Tiles[MyFloor[Y][X]]
				if cell.Mat == "Dirt" then
					cell.Ind = false
				else
					cell.Ind = true
				end
			end
		end
	end
	MyStove = Object.Spawn("OutdoorStove",this.Pos.x,this.Pos.y-0.5)
	Set(MyStove,"Ind",true)
	Set(MyStove,"HasFoundation",true)
	Set(MyStove,"FoundationType","Iron")
	MyRackLeft = Object.Spawn("FireplaceLogRack",this.Pos.x-0.65,this.Pos.y-0.2)
	Set(MyRackLeft,"StoveID",MyStove.Id.u)
	MyRackRight = Object.Spawn("FireplaceLogRack",this.Pos.x+0.65,this.Pos.y-0.2)
	Set(MyRackRight,"StoveID",MyStove.Id.u)
	MyLogLeft = Object.Spawn("Log",this.Pos.x-0.75,this.Pos.y)
	Set(MyLogLeft,"StoveID",MyStove.Id.u)
	MyLogRight = Object.Spawn("Log",this.Pos.x+0.75,this.Pos.y)
	Set(MyLogRight,"StoveID",MyStove.Id.u)
	if Christmas == true then
		SocksRight = Object.Spawn("ChristmasSock"..math.random(1,5),this.Pos.x+1.5,this.Pos.y)
		Set(SocksRight,"StoveID",MyStove.Id.u)
		SocksLeft = Object.Spawn("ChristmasSock"..math.random(1,5).."L",this.Pos.x-1.5,this.Pos.y)
		Set(SocksLeft,"StoveID",MyStove.Id.u)
	end
end
